#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

 #####									#####
 #									    #
 #		TOMMASO.TCL			Tommaso Di Lemma	    #
 #									    #
#	H	data creation : 19/09/03				     #
#	H	data 2nd step : 17/10/03				     #
#	H	author        : Dario Zanotti				     #
#	H	-------------------------------------------------------      #
 #									    #
 #####									#####


set	NOMECOD	"Tommaso.tcl"
set	RELEASE	"02.00.40"
set	DATAVAR	"20/10/04"

 #####									  #####
 #									      #
 #		PROCEDURA TCL  GETOPT					      #
 #									      #
 #####									  #####

proc	XE_getopt	{ argslist optstring optret argret } {

	global	OPTIND OPTINDC
	upvar	$optret  retvar
	upvar	$argret  optarg

	set	optarg  ""
	set	retvar  ""
	set	retval  0
	if	{ $OPTIND < [ llength $argslist ] } then {
		switch	-glob -- [ set  arg [ lindex  $argslist $OPTIND ] ] {
		"--"	{
			incr	OPTIND
			}
                "-*"	{
		        if	{ $OPTINDC < 1 } then {
				set	OPTINDC  1
				}
			set	retval  1
			set	opt  [ string  index  $arg $OPTINDC ]
			if	{ [ incr  OPTINDC ] == [ string  length  $arg ] } then {
				set	arg  [ lindex  $argslist [ incr  OPTIND ] ]
				set	OPTINDC  0
				}
			if	{ [ string  match  "*$opt*" $optstring ] } then {
				set	retvar  $opt
				if	{ [ string  match  "*$opt:*" $optstring ] } then {
					if	{ $OPTIND < [ llength $argslist ] } then {
						set	optarg  [ string  range  $arg $OPTINDC end ]
						incr	OPTIND
						set	OPTINDC  0
					} else {
						set	optarg  "Option requires an argument -- $opt"
						set	retvar  "?"
						}
					}
			} else {
				set	optarg  "Illegal option -- $opt"
				set	retvar  "?"
				}
			}
			}
		}
	return	$retval
	}

set	OPTRET  ""
set	OPTARG  ""
set	OPTIND  0
set	OPTINDC  0
set	AR(Flag,NomeFile)  ""
set	AR(Flag,NomeDiz)  ""
set	AR(Flag,Colore)  ""
set	AR(Flag,Exec)  ""
set	AR(Flag,Accentazione)  "italiano moderno (1)"
set	AR(Flag,CkOCR)  "SI"
set	AR(Flag,CkPunt)  "SI"
set	AR(Flag,Tag)  0

while	{ [ XE_getopt  $argv "f:C:D:E:OPTX" OPTRET OPTARG ] } {
	switch	-exact	"$OPTRET" {
	"f"	{	set	AR(Flag,NomeFile)  "$OPTARG"
			if	{ [ file  readable  "$AR(Flag,NomeFile)" ] == 0 } {
				puts	"File $AR(Flag,NomeFile) non leggibile da $NOMECOD"
				puts	"$NOMECOD: $OPTARG - Sintassi: $NOMECOD \[ -f NomeFile \] \[ -C Colore \] \[ -D NomeDiz \] \[ -E ERR|NOM|LEM|FRQ \]  \[ -OPX | T \]"
				exit
				}
			}
	"C"	{	set	AR(Flag,Colore)  "$OPTARG"
			}
	"D"	{	set	AR(Flag,NomeDiz)  "$OPTARG"
			if	{ [ file  readable  "$AR(Flag,NomeDiz)" ] == 0 } {
				puts	"File $AR(Flag,NomeDiz) non leggibile da $NOMECOD"
				puts	"$NOMECOD: $OPTARG - Sintassi: $NOMECOD \[ -f NomeFile \] \[ -C Colore \] \[ -D NomeDiz \] \[ -E ERR|NOM|LEM|FRQ \]  \[ -OPX | T \]"
				exit
				}
			}
	"E"	{	switch	-glob -- "$OPTARG" {
			"ERR"	-
			"NOM"	-
			"LEM"	-
			"FRQ"	{	set	AR(Flag,Exec)  "$OPTARG"
					}
			default	{	puts	"Opzione flag -E non valida ($OPTARG)"
					exit
					}
		}
			}
	"O"	{	set	AR(Flag,CkOCR)  "NO"
			}
	"P"	{	set	AR(Flag,CkPunt)  "NO"
			}
	"T"	{	set	AR(Flag,CkOCR)  "NO"
			set	AR(Flag,CkPunt)  "NO"
			}
	"X"	{	set	AR(Flag,Tag)  1
			}
	default	{	puts	"$NOMECOD: $OPTARG - Sintassi: $NOMECOD \[ -f NomeFile \] \[ -C Colore \] \[ -D NomeDiz \] \[ -E ERR|NOM|LEM|FRQ \]  \[ -OPX | T \]"
			exit
			}
		}
	}

wm	title .		"Tommaso Di Lemma"
wm	iconname .	"Tommaso"
tk_setPalette	"#e0eee0"


#	XDL_B1_ERT	-	BUTTON 1 NEL TEXT DEGLI ERRORI
#	------------------------------------------------------------------------

proc	XDL_B1_ert {} {

	global	AR

	if	{ $AR(Current,Analisi) != "ERR" } {
		return
		}
	focus	.ert.sca
	set	ErrNum  [ lindex  [ split  [ .ert.txt.dat  index  current ] "." ] 0 ]
	XDL_errOut	$ErrNum
	}

#	XDL_B1_LER	-	BUTTON 1 NEL TEXT DEI LEMMI IN ERRORE
#	------------------------------------------------------------------------

proc	XDL_B1_ler {} {

	global	AR

	if	{ $AR(Current,Analisi) != "ERR" } {
		return
		}
	set	Ind  [ .ler.txt.dat  index  current ]
	.ler.txt.dat	tag remove  Evidenzia  0.0 end
	.ler.txt.dat	tag add  Evidenzia  "$Ind linestart" "$Ind lineend"
	set	Riga  [ .ler.txt.dat  get  "$Ind linestart" "$Ind lineend" ]
	set	AR(Lem,Parola)  [ string  trim [ lindex  [ split  "$Riga" "()" ] 0 ] ]
	focus	.ler.sca

	set	AR(Current,Lemma)  "$AR(Lem,Parola)"
	XDL_lerTop

	.ler.sca	config  -from 1  -to [ llength  $AR(Lem,Pos,$AR(Lem,Parola)) ]  -tickinterval [ expr  [ llength  $AR(Lem,Pos,$AR(Lem,Parola)) ] - 1 ]  -command { XDL_lerPar Scala }
	.ler.sca	set  1
	set	AR(Current,Ler)  1
	XDL_lerPar	1
	}

#	XDL_B1_LVA	-	BUTTON 1 NEL TEXT DEI LEMMI VALIDI
#	------------------------------------------------------------------------

proc	XDL_B1_lva {} {

	global	AR

	set	Ind  [ .lva.txt.dat  index  current ]
	.lva.txt.dat	tag remove  Evidenzia  0.0 end
	.lva.txt.dat	tag add  Evidenzia  "$Ind linestart" "$Ind lineend"
	set	Riga  [ .lva.txt.dat  get  "$Ind linestart" "$Ind lineend" ]
	set	ls_Riga  [ split  "$Riga" "-()" ]
	if	{ [ llength  $ls_Riga ] == 0 } {
		return
		}
	if	{ [ llength  $ls_Riga ] == 2 } {
		set	AR(Lem,Parola)  [ string  trim [ lindex  $ls_Riga 1 ] ]
	} else {
		set	AR(Lem,Parola)  [ string  trim [ lindex  $ls_Riga 0 ] ]
		}
	focus	.lva.sca

	.lva.top.ent	delete  0 end
	.lva.top.dat	delete  0.0 end
	set	ParDiz  $AR(Lem,Parola)
	if	{ [ string  is upper  $AR(Lem,Parola) ] == 1 } {
		set	ParDiz  [ string  tolower  $AR(Lem,Parola) ]
		}
	if	{ [ info  exists  AR(DV,$ParDiz) ] } {
		set	StriDiz  "diz:S  ($ParDiz)  R"
	} else {
		if	{ [ XDL_dizTrova  $ParDiz ] == 1 } {
			set	StriDiz  "diz:S  ($ParDiz)  S"
		} else {
			set	ParDiz  [ string  range  $AR(Lem,Parola)  0 0 ]
			append	ParDiz  [ string  tolower  [ string  range  $AR(Lem,Parola)  1 end ] ]
			if	{ [ info  exists  AR(DV,$ParDiz) ] == 1  ||  [ XDL_dizTrova  $ParDiz ] == 1 } {
				set	StriDiz  "diz:S  ($ParDiz)  N"
			} else {
				set	StriDiz  "diz:No  ($ParDiz)"
				}
			}
		}
	.lva.top.ent	insert end  "$AR(Lem,Parola)"
	.lva.top.dat	insert end  "$StriDiz"

	.lva.sca	config  -from 1  -to [ llength  $AR(Lem,Pos,$AR(Lem,Parola)) ]  -tickinterval [ expr  [ llength  $AR(Lem,Pos,$AR(Lem,Parola)) ] - 1 ]  -command { XDL_lerPar }
	.lva.sca	set  1
	XDL_lemPar	1
	}

#	XDL_B1_PAR	-	BUTTON 1 NEL TEXT DEI PARAGRAFI
#	------------------------------------------------------------------------

proc	XDL_B1_par {} {

	global	AR

	if	{ $AR(Current,Analisi) != "ERR" } {
		return
		}
	set	Ind  [ .par.txt.dat  index  current ]
	set	Lemma  [ .par.txt.dat  get  "$Ind wordstart" "$Ind wordend" ]
	focus	.par.sca
	if	{ $AR(Current,Analisi) == "LEM"  ||  $AR(Current,Analisi) == "FRQ" } {
		set	Lemma  [ string  toupper  "$Lemma" ]
		}
	if	{ [ info  exists  AR(Lem,R,$Lemma) ] == 0 } {
		return
		}
	if	{ $AR(Current,Analisi) == "FRQ" } {
		set	Lemma  "\[ 0-9\]* - $Lemma"
		}
	if	{ [ lsearch  ErS [ .par.txt.dat  tag names  $Ind ] ] > -1 } {
		XDL_lemAlfa	LER  $Lemma
	} else {
		XDL_lemAlfa	LVA  $Lemma
		}
	}

#	XDL_B1_TIP	-	BUTTON 1 NEL TEXT DEI TIPI ERRORE
#	------------------------------------------------------------------------

proc	XDL_B1_tip {} {

	global	AR

	set	Ind  [ .tip.txt.dat  index  current ]
	.tip.txt.dat	tag remove  Evidenzia  0.0 end
	.tip.txt.dat	tag add  Evidenzia  "$Ind linestart" "$Ind lineend"
	set	Riga  [ .tip.txt.dat  get  "$Ind linestart" "$Ind lineend" ]
	if	{ "$Riga" == "" } {
		return
		}
	set	AR(Current,Tipo)  [ string  trim [ lindex  [ split  "$Riga" ":" ] 0 ] ]
	focus	.tip.sca

	XDL_tipTop
	.tip.sca	config  -from 1  -to [ llength  $AR(Tipo,lsE,$AR(Current,Tipo)) ]  -tickinterval [ expr  [ llength  $AR(Tipo,lsE,$AR(Current,Tipo)) ] - 1 ]  -command { XDL_tipPar Scala }
	set	AR(Current,TipSca)  1
	.tip.sca	set  1
	XDL_tipPar	1
	}

#	XDL_CAMBIOACC	-	CAMBIA IL TIPO DI ACCENTAZIONE
#	------------------------------------------------------------------------

proc	XDL_cambioAcc { NeoAcc } {

	global	AR

	switch	-exact -- "$AR(Flag,OldAcc)" {
	"italiano moderno (1)"	{	set	FileAcc  "integrazioni/IM.diz"
					}
	"italiano moderno (2)"	{	set	FileAcc  "integrazioni/IM2.diz"
					}
	"solo accenti gravi"	{	set	FileAcc  "integrazioni/SG.diz"
					}
		}
	set	pf_Acc  [ open  "$FileAcc" "r" ]
	while	{ [ gets  $pf_Acc Riga ] != -1 } {
		set	ls_Riga  [ split  "$Riga" "/" ]
		unset	AR(DV,[ lindex  $ls_Riga 0 ])
		}
	close	$pf_Acc

	switch	-exact -- "$NeoAcc" {
	"italiano moderno (1)"	{	set	FileAcc  "integrazioni/IM.diz"
					}
	"italiano moderno (2)"	{	set	FileAcc  "integrazioni/IM2.diz"
					}
	"solo accenti gravi"	{	set	FileAcc  "integrazioni/SG.diz"
					}
		}
	XDL_dizCarica	$FileAcc
	set	AR(Flag,OldAcc)  "$NeoAcc"
	}

#	XDL_CKLEMMA	-	VERIFICA UN LEMMA E NE SEGNALA L'ANALISI
#	------------------------------------------------------------------------

proc	XDL_ckLemma { Parola } {

	global	AR

	if	[ info  exists  AR(Lem,R,$Parola) ] {
		if	{ $AR(Lem,R,$Parola) == "OK" } {
			XDL_lemRegistra  OK  $Parola
			return
		} else {
			set	ComT  $AR(Lem,R,$Parola)
			XDL_lemRegistra  NO  $Parola
			XDL_errRegistra  $ComT  $Parola
			return
			}
		}

		# esclamazioni e onomatopeismi accettati

	set	ParMin  [ string  tolower  "$Parola" ]

	switch	-glob -- "$ParMin" {
	"\[aeo\]hi"		-
	"\[aeiou\]h"		-
	"\[ao\]him"		-
	"b\[aeo\]h"		-
	"deh"			-
	"ehm"			-
	"hi"			-
	"hop"			-
	"mah"			-
	"ohib"			-
	"t\[aio\]c"		-
	"toh"			-
	"uhm"			-
	"veh"			{	XDL_lemRegistra  OK  $ParMin
					return
					}
		}

		# ck BASE	numeri e lettere insieme

	if	{ [ regexp  "\[0-9\]\[a-z\]" "$ParMin" ]  ||  [ regexp  "\[a-z\]\[0-9\]" "$ParMin" ] } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	NLI  "$Parola"
		return
		}

		# ck BASE	maiuscole e minuscole insieme

	if	{ [ regexp  "\[a-z\]\[A-Z\]" "$Parola" ]  ||  [ regexp  "\[A-Z\]\[A-Z\]\[a-z\]" "$Parola" ]  ||  [ regexp  "\[A-Z\]\[a-z\]\[A-Z\]" "$Parola" ] } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	MMI  "$Parola"
		return
		}

		# ck DIZ	parola presente nel dizionario (secca): a minuscolo, cosi` com'e`, se nome tutto maiuscolo

	if	{ [ info  exists  AR(DV,$ParMin) ] } {
		XDL_lemRegistra  OK  $ParMin
		return
		}
	if	{ [ info  exists  AR(DV,$Parola) ] } {
		XDL_lemRegistra  OK  $Parola
		return
		}
	if	{ [ string  is upper  "$Parola" ] } {
		set	ParCom  [ string  range  "$Parola"  0 0 ]
		append	ParCom  [ string  tolower  [ string  range  "$Parola"  1 end ] ]
		if	{ [ info  exists  AR(DV,$ParCom) ] } {
			XDL_lemRegistra  OK  $ParCom
			return
			}
		}

		# ck DIZ	controllo nel dizionario con suffissi

	if	{ [ XDL_dizTrova  "$ParMin" ] == 1 } {
		XDL_lemRegistra  OK  $ParMin
		return
	} else {
		if	{ [ string  is  lower  "$Parola" ] == 0 } {
			if	{ [ XDL_dizTrova  "$Parola" ] == 1 } {
				XDL_lemRegistra  OK  $Parola
				return
			} else {
				set	Errcode  DIN
				}
		} else {
			set	Errcode  DIP
			}
		}

		# ck BASE	solo numeri - accettati

	if	[ string  is integer  "$Parola" ] {
		XDL_lemRegistra  OK  $Parola
		return
		}

		# ck BASE	numeri romani

	if	{ [ regexp  "^\[mdclxvi\]+\$" "$ParMin" ] == 1 } {
		regsub	"\[lxvi\]*\$" "$ParMin"  "" Com1
		regsub	"xc\$" "$Com1"  "" Rom
		if	{ [ regexp  "^\[m\]*\[d\]?\[c\]*\$" "$Rom" ] == 0  &&  [ regexp  "^\[m\]*c\[md\]\$" "$Rom" ] == 0 } {
			XDL_lemRegistra  NO  $Parola
			XDL_errRegistra	NRE  "$Parola"
			return
			}
		regsub	"i\[xv\]\$" "$ParMin"  "" Com1
		regsub	"\[vi\]*\$" "$Com1"  "" Com2
		regsub	"^\[md\]*" "$Com2"  "" Com3
		regsub	"^c\[md\]" "$Com3"  "" Rom
		if	{ [ regexp  "^\[c\]*\[l\]?\[x\]*\$" "$Rom" ] == 0  &&  [ regexp  "^\[c\]*x\[cl\]\$" "$Rom" ] == 0 } {
			XDL_lemRegistra  NO  $Parola
			XDL_errRegistra	NRE  "$Parola"
			return
			}
		regsub	"^\[mdcl\]*" "$ParMin"  "" Com1
		regsub	"^x\[cl\]" "$Com1"  "" Rom
		if	{ [ regexp  "^\[x\]*\[v\]?\[i\]*\$" "$Rom" ] == 0  &&  [ regexp  "^\[x\]*i\[xv\]\$" "$Rom" ] == 0 } {
			XDL_lemRegistra  NO  $Parola
			XDL_errRegistra	NRE  "$Parola"
			return
			}
		XDL_lemRegistra  OK  $Parola
		return
		}

		# ck BASE	uso errato lettera Q

	if	[ regexp  "q\[^u\]" "$ParMin" ] {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	?Q?  "$Parola"
		return
		}

		# ck BASE	uso errato lettera H

	if	{ [ regexp  "\[^cg\]h" "$ParMin" ] == 1  ||  [ regexp  "h\[^ei\]" "$ParMin" ] == 1 } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	?H?  "$Parola"
		return
		}

		# ck BASE	lettere straniere (JKWXY) nella parola

	if	[ regexp  "\[jkwxy\]" "$ParMin" ] {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	LKP  "$Parola"
		return
		}

		# ck BASE	analisi consonanti

	set	ls_Atomi  [ split  "$ParMin" "aeiou" ]

		# ck BASE	4 consonanti di seguito non ammesse

	foreach	Atomo  $ls_Atomi {
		if	[ regexp  "\[bcdfgjlmnprstvz\]\[bcdfgjlmnprstvz\]\[bcdfgjlmnprstvz\]\[bcdfgjlmnpqrstvz\]" "$Atomo" ] {
			XDL_lemRegistra  NO  $Parola
			XDL_errRegistra	4_C  "$Parola"
			return
			}
		}

		# ck BASE	parola che inizia con 3 consonanti non ammesse

	set	Primo  [ string  map  {	"sbr" ""
					"scl" ""
					"scr" ""
					"sdr" ""
					"sfr" ""
					"sgr" ""
					"spl" ""
					"spr" ""
					"str" "" }	[ lindex  $ls_Atomi 0 ] ]
	if	[ regexp  "\[bcdfgjlmnprstvz\]\[bcdfgjlmnprstvz\]\[bcdfgjlmnpqrstvz\]" "$Primo" ] {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	I3C  "$Parola"
		return
		}

		# ck BASE	parola che inizia con 2 consonanti non ammesse

	set	Primo  [ lindex  $ls_Atomi 0 ]
	switch	-glob -- "$Primo" {
	"b\[bcdfgjmnpqstvz\]" -
	"c\[bcdfgjmpqstvz\]" -
	"d\[bcdfgjlmnpqstvz\]" -
	"f\[bcdfgjmnpqstvz\]" -
	"g\[bcdfgjmpqstvz\]" -
	"p\[bcdfgjmpqtvz\]" -
	"s\[jsz\]"	-
	"t\[bcdfgjlmnpqstvz\]" {
				XDL_lemRegistra  NO  $Parola
				XDL_errRegistra	I2C  "$Parola"
				return
				}
		}
	if	[ regexp  "\[jlmnrvz\]\[bcdfgjlmnpqrstvz\]" "$Primo" ] {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	I2C  "$Parola"
		return
		}

		# ck BASE	3 consonanti di seguito non ammesse

	set	Ct  0
	foreach	Atomo  $ls_Atomi {
		if	{ $Ct == 0 } {
			set	Ct  1
			continue
			}
		if	[ regexp  "\[bcdfgjlmnprstvz\]\[bcdfgjlmnprstvz\]\[bcdfgjlmnpqrstvz\]\$" "$Atomo" ] {
			switch	-glob -- "$Atomo" {
			"bb\[lr\]"	-
			"cc\[lr\]"	-
			"ddr"		-
			"ff\[lr\]"	-
			"gg\[lr\]"	-
			"lcr"		-
			"ldr"		-
			"lgr"		-
			"lst"		-
			"ltr"		-
			"mb\[lr\]"	-
			"mgl"		-
			"mp\[lr\]"	-
			"nc\[lr\]"	-
			"nf\[lr\]"	-
			"ng\[lr\]"	-
			"ndr"		-
			"ns\[cfpt\]"	-
			"ntr"		-
			"pp\[lr\]"	-
			"rfl"		-
			"rgl"		-
			"rp\[lr\]"	-
			"rs\[pt\]"	-
			"rtr"		-
			"sbr"		-
			"sc\[lr\]"	-
			"sdr"		-
			"sfr"		-
			"sgr"		-
			"sp\[lr\]"	-
			"st\[mr\]"	-	
			"ttr"		{	
						}
			default		{	XDL_lemRegistra  NO  $Parola
						XDL_errRegistra	3_C  "$Parola"
						return
						}
				}
			}
		}

		# ck BASE	parola che finisce con 2 consonanti

	set	Ultimo  [ lindex  $ls_Atomi end ]
	if	{ [ string  length  "$Ultimo" ] == 2 } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	DCF  "$Parola"
		return
		}

		# ck BASE	parola che finisce con consonante non ammessa

	if	{ [ string  length  "$Ultimo" ] == 1  &&  [ regexp  "\[bcdfghlmnpqrstvz\]" "$Ultimo" ] == 1  &&  [ string  length  "$Parola" ] > 1 } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	SCF  "$Parola"
		return
		}

		# ck CARD	numeri cardinali e derivati

	set	Reg  [ regsub  "enn\[ei\]\$" $ParMin  "" ComD ]
	if	{ $Reg == 0 } {
		set	Reg  [ regsub  "esim\[oiae\]\$" $ParMin  "" ComD ]
		}
	if	{ $Reg == 1 } {
		switch	-regexp -- $ComD {
		"ant\$"		-
		"mil\$"		-
		"trent\$"	{	append	ComD  "a"
					}
		"cinqu\$"	-
		"du\$"		-
		"mill\$"	-
		"nov\$"		-
		"sett\$"	{	append	ComD  "e"
					}
		"diec\$"	-
		"dic\$"		-
		"vent\$"	{	append	ComD  "i"
					}
		"cent\$"	-
		"ott\$"		-
		"quattr\$"	-
		"un\$"		{	append	ComD  "o"
					}
		"tre\$"		{	regsub	"tre\$" $ComD  "tr" Com1
					set	ComD  $Com1
					}
			}
		}

	if	{ [ regexp  "mila" $ComD ] == 1 } {
		regsub	"^(due|tre|quattro|cinque|sei|sette|otto|nove)?cento" $ComD  "" Com1
		set	Reg  [ regsub  "^(dieci|undici|dodici|tredici|quattordici|quindici|sedici|diciassette|diciotto|diciannove)" $Com1  "" Com2 ]
		if	{ $Reg == 0 } {
			set	Reg  [ regsub  "^(venti|trenta|quaranta|cinquanta|sessanta|settanta|ottanta|novanta)?(uno|due|tre|quattro|cinque|sei|sette|otto|nove)?" $Com1  "" Com2 ]
			}
		if	{ $Reg == 0 } {
			set	Reg  [ regsub  "^(vent|trent|quarant|cinquant|sessant|settant|ottant|novant)(uno|otto)" $Com1  "" Com2 ]
			}
		if	{ $Reg == 1 } {
			regsub	"^mila" $Com2  "" ComM
			}
	} else {
		regsub	"^mille" $ComD  "" ComM
		}
	if	{ [ regexp  "cento" $ComM ] == 1 } {
		regsub	"^(due|tre|quattro|cinque|sei|sette|otto|nove)?cento" $ComM  "" ComC
	} else {
		set	ComC  $ComM
		}
	set	Reg  [ regsub  "^(dieci|undici|dodici|tredici|quattordici|quindici|sedici|diciassette|diciotto|diciannove)\$" $ComC  "" ParCar ]
	if	{ $Reg == 0 } {
		set	Reg  [ regsub  "^(venti|trenta|quaranta|cinquanta|sessanta|settanta|ottanta|novanta)?(uno|due|tr|quattro|cinque|sei|sette|otto|nove)?\$" $ComC  "" ParCar ]
		}
	if	{ $Reg == 0 } {
		regsub	"^(vent|trent|quarant|cinquant|sessant|settant|ottant|novant)(uno|otto)\$" $ComC  "" ParCar
		}
	if	{ "$ParCar" == "" } {
		XDL_lemRegistra  OK  $Parola
		return
		}

		# ck BASE	analisi vocali

	set	ls_Atomi  [ split  "$ParMin" "bcdfghlmnpqrstvz" ]

		# ck BASE	3 vocali di seguito non ammesse / 2 vocali uguali di seguito

	foreach	Atomo  $ls_Atomi {
		if	{ [ string  length  "$Atomo" ] == 3 } {
			switch	-glob -- "$Atomo" {
			"ai\[aeou\]"	-
			"eie"		-
			"iai"		-
			"ie\[ai\]"	-
			"ioi"		-
			"iuo"		-
			"oi\[aeo\]"	-
			"uai"		-
			"uei"		-
			"ui\[aeo\]"	-
			"uie"		-
			"uio"		-
			"uoi"		{	
						}
			default		{	XDL_lemRegistra  NO  $Parola
						XDL_errRegistra	3_V  "$Parola"
						return
						}
				}
			}
		switch	-glob -- "$Atomo" {
		"aa"		-
		"ee"		-
		"ii"		-
		"oo"		-
		"uu"		{	XDL_lemRegistra  NO  $Parola
					XDL_errRegistra	2VU  "$Parola"
					return
					}
			}
		}

		# ck BASE	lettera U finale

	set	Ultimo  [ string  range  "$ParMin"  end end ]
	if	[ regexp  "u\$" "$Parola" ] {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	LUF  "$Parola"
		return
		}

		# ck ACCE	A: va bene per tutti gli stili d'accentazione: solo grave

	if	[ regexp  "\[\]\$" "$Parola" ] {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_A  "$Parola"
		return
		}
			
		# ck ACCE	E: SoloGrave: solo grave / gli altri: acuto o grave, decide il dizionario

	if	[ regexp  "\[\]\$" "$Parola" ] {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_A  "$Parola"
		return
		}
	if	{ [ regexp  "\[\]\$" "$Parola"  &&  $AR(Flag,Accentazione) != "solo accenti gravi" ] } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_G  "$Parola"
		return
		}
			
		# ck ACCE	I: Einaudi: solo acuto / gli altri: solo grave, decide il dizionario

	if	{ [ regexp  "\[\]\$" "$Parola" ] == 1  &&  $AR(Flag,Accentazione) != "italiano moderno (2)" } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_A  "$Parola"
		return
		}
	if	{ [ regexp  "\[\]\$" "$Parola" ] == 1  &&  $AR(Flag,Accentazione) == "italiano moderno (2)" } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_G  "$Parola"
		return
		}
			
		# ck ACCE	O: va bene per tutti gli stili d'accentazione: solo grave

	if	{ [ regexp  "\[\]\$" "$Parola" ] == 1 } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_A  "$Parola"
		return
		}
			
		# ck ACCE	U: Einaudi: solo acuto / gli altri: solo grave, decide il dizionario

	if	{ [ regexp  "\[\]\$" "$Parola" ] == 1  &&  $AR(Flag,Accentazione) != "italiano moderno (2)" } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_A  "$Parola"
		return
		}
	if	{ [ regexp  "\[\]\$" "$Parola" ] == 1  &&  $AR(Flag,Accentazione) == "italiano moderno (2)" } {
		XDL_lemRegistra  NO  $Parola
		XDL_errRegistra	A_G  "$Parola"
		return
		}

	XDL_lemRegistra  NO  $Parola
	XDL_errRegistra	$Errcode  "$Parola"
	}

#	XDL_CKPAR	-	VERIFICA UN PARAGRAFO E NE SEGNALA L'ANALISI
#	------------------------------------------------------------------------

proc	XDL_ckPar {} {

	global	AR

		# ck BASE	uso errato apostrofo

	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  "\[BCDFGHJLMNPRSTVZbcdfghjlmnprstvz\]'\[BCDFGJLMNPQRSTVZbcdfgjlmnpqrstvz\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)" $AR(Pos) ]
		XDL_errRegistra	UEA  "$Parola"
		incr	AR(Pos)  3
		}
	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  "\[AEIOUaeiou\]'\[AEIOUaeiou\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)" $AR(Pos) ]
		XDL_errRegistra	UEA  "$Parola"
		incr	AR(Pos)  3
		}
	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  "\[bcdfglmnprstvz\]' " "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)" $AR(Pos) ]
		XDL_errRegistra	SDA  "$Parola"
		incr	AR(Pos)  3
		}

		# ck PUNT	doppia spaziatura

	set	AR(Pos)  0
	while	{ [ string  first  "  " "$AR(Riga)" $AR(Pos) ] > -1 } {
		set	AR(Pos)  [ string  first  "  " "$AR(Riga)" $AR(Pos) ]
		XDL_errRegistra	RDS  "  "
		incr	AR(Pos)  2
		}

		# ck PUNT	punteggiatura senza spazio dopo

	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  "\[^.\]\[^.\]\[!\?.,:;\]\[a-zA-Z\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)"  $AR(Pos) ]
		XDL_errRegistra	RPS  "$Parola"
		incr	AR(Pos)  2
		}


		# ck PUNT	punteggiatura con spazio prima

	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  " \[!\?.,:;\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)"  $AR(Pos) ]
		XDL_errRegistra	RSP  "$Parola"
		incr	AR(Pos)  2
		}

		# ck PUNT	punteggiatura doppia

	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  "\[!\?.,:;\]\[!\?.,:;\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)"  $AR(Pos) ]
		if	{ [ string  range  "$AR(Riga)"  $AR(Pos) [ expr  $AR(Pos) + 3 ] ] == "...." } {
			incr	AR(Pos)  4
			continue
			}
		if	{ [ string  range  "$AR(Riga)"  $AR(Pos) [ expr  $AR(Pos) + 2 ] ] == "..." } {
			incr	AR(Pos)  3
			continue
			}
		if	{ [ string  range  "$AR(Riga)"  [ expr  $AR(Pos) + 1 ] [ expr  $AR(Pos) + 4 ] ] == "...." } {
			incr	AR(Pos)  5
			continue
			}
		if	{ [ string  range  "$AR(Riga)"  [ expr  $AR(Pos) + 1 ] [ expr  $AR(Pos) + 3 ] ] == "..." } {
			incr	AR(Pos)  4
			continue
			}
		XDL_errRegistra	RDP  "$Parola"
		incr	AR(Pos)  2
		}

		# ck PUNT	iniziale a minuscolo

	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  " \[a-z\]\[.\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)"  $AR(Pos) ]
		XDL_errRegistra	IMI  "$Parola"
		incr	AR(Pos)  3
		}

		# ck PUNT	iniziale senza punto dopo

	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  " \[BCDFGHJKMNPQRSTUWYZ\]\[^.'A-Za-zo\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)"  $AR(Pos) ]
		XDL_errRegistra	ISP  "$Parola"
		incr	AR(Pos)  3
		}

		# ck PUNT	grado o percentuale senza numero prima

	set	AR(Pos)  0
	while	{ [ regexp  -start $AR(Pos) --  "\[^0-9\]\[%\]" "$AR(Riga)"  Parola ] == 1 } {
		set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)"  $AR(Pos) ]
		XDL_errRegistra	GPN  "$Parola"
		incr	AR(Pos)  2
		}

	set	RigaMai  [ string  toupper  "$AR(Riga)" ]

		# ck OCR	da file .aff

	for	{ set Ind 0 } { $Ind<$AR(D,OCRind) } { incr Ind } {
		set	AR(Pos)  0
		if	{ $AR(OCR,Riga,$Ind) == "M" } {
			set	RigaOCR  "$RigaMai"
		} else {
			set	RigaOCR  "$AR(Riga)"
			}
		while	{ [ regexp  -start $AR(Pos) --  $AR(OCR,Cond,$Ind) "$RigaOCR"  Parola ] == 1 } {
			set	AR(Pos)  [ string  first  "$Parola" "$RigaOCR"  $AR(Pos) ]
			XDL_errRegistra	$AR(OCR,Tipo,$Ind)  "$Parola"
			incr	AR(Pos)  [ string  length  "$Parola" ]
			}
		}
	}

#	XDL_DIZCAMBIA	-	CAMBIA IL DIZIONARIO BASE
#	------------------------------------------------------------------------

proc	XDL_dizCambia {} {

	global	AR

	set	FileDiz  [ tk_getOpenFile  -parent .  -title "Nome del nuovo dizionario base:" ]
	if	{ "$FileDiz" == "" } {
		return
		}

	XDL_messaggio	WAIT  "Cancellazione di tutte le voci del vecchio dizionario..."
	unset	AR(D,ls_Diz)
	set	AR(DI,PFX,ls)  {}
	set	AR(D,OCRind)  0

	foreach	Item  [ array  names  AR "DV,*" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "D,*,vers" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "D,*,desc" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "OCR,Cond,*" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "OCR,Tipo,*" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "DI,SFX,*" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "DA,*,T" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "DA,*,I" ] {
		unset	AR($Item)
		}
	foreach	Item  [ array  names  AR "DA,*,E" ] {
		unset	AR($Item)
		}

	XDL_dizCarica	$FileDiz
	}

#	XDL_DIZCARAFF	-	CARICA IL FILE AFF DI UN DIZIONARIO
#	------------------------------------------------------------------------

proc	XDL_dizCarAff { DizNome } {

	global	AR

	regsub	".diz\$" $DizNome  ".aff" FileAff
	if	{ [ file  exists  $FileAff ] == 0 } {
		lappend	AR(D,ls_Diz)  "?"
		return
		}

	set	pf_Diz  [ open  "$FileAff" "r" ]
	set	Ind  0
	while	{ [ gets  $pf_Diz Riga ] > -1 } {
		switch	-glob -- "$Riga" {
		"IDENTIFICATI*"	{	set	DizId  [ lindex  [ split  "$Riga" "(/)" ] 1 ]
					lappend	AR(D,ls_Diz)  $DizId
					set	AR(D,$DizId,tipo)  [ lindex  [ split  "$Riga" "(/)" ] 2 ]
					}
		"VERSIONE*"	{	set	AR(D,$DizId,vers)  [ lindex  [ split  "$Riga" "()" ] 1 ]
					}
		"DESCRIZIONE*"	{	set	AR(D,$DizId,desc)  [ lindex  [ split  "$Riga" "()" ] 1 ]
					}
		"OCR*"		{	set	AR(OCR,Cond,$AR(D,OCRind))  [ string  map  { "\\"  "" } \
											[ lindex  [ split  "$Riga" "()\t" ] 1 ] ]
					set	AR(OCR,Riga,$AR(D,OCRind))  [ lindex  [ split  "$Riga" "()\t" ] 3 ]
					set	AR(OCR,Tipo,$AR(D,OCRind))  [ lindex  [ split  "$Riga" "()\t" ] end ]
					incr	AR(D,OCRind)
					}
		"PFX*"		{	set	Prefisso  [ lindex  [ split  "$Riga" ] end ]
					if	{ "$Prefisso" == "." } {
						continue
						}
					lappend	AR(DI,PFX,ls)  $Prefisso
					}
		"SFX*"		{	set	ls_Riga  [ split  "$Riga" ]
					incr	Ind
					set	Finale  [ string  range  [ lindex  $ls_Riga 3 ]  end end ]
					lappend	AR(DI,[ lindex  $ls_Riga 0 ],$Finale)  $Ind
					set	AR(DA,$Ind,T)  [ lindex  $ls_Riga 1 ]
					set	AR(DA,$Ind,I)  [ lindex  $ls_Riga 2 ]
					if	{ $AR(DA,$Ind,I) == 0 } {
						set	AR(DA,$Ind,I)  ""
						}
					set	AR(DA,$Ind,E)  [ lindex  $ls_Riga 3 ]
					}
		"RSFX*"		{	set	ls_Riga  [ split  "$Riga" ]
					set	Finale  [ string  range  [ lindex  $ls_Riga 3 ]  end end ]
					set	Tipo  [ lindex  $ls_Riga 1 ]
					set	OldSuff  [ lindex  $ls_Riga 3 ]
					if	{ [ info  exists  AR(DI,SFX,$Finale) ] == 0 } {
						puts	"Errore nel dizionario: $DizId ($Riga)"
						continue
						}
					set	Ct  0
					foreach	IndS  $AR(DI,SFX,$Finale) {
						if	{ $AR(DA,$IndS,T) == $Tipo } {
							set	AR(DA,$IndS,E)  [ lindex  $ls_Riga 5 ]
							set	AR(DI,SFX,$Finale)  [ lreplace  $AR(DI,SFX,$Finale)  $Ct $Ct ]
							break
							}
						incr	Ct
						}
					set	Finale  [ string  range  [ lindex  $ls_Riga 5 ]  end end ]
					lappend	AR(DI,SFX,$Finale)  $IndS
					}
			}
		}
	close	$pf_Diz
	}

#	XDL_DIZCARICA	-	CARICA UN DIZIONARIO BASE
#	------------------------------------------------------------------------

proc	XDL_dizCarica { DizNome } {

	global	AR

	XDL_messaggio	WAIT  "Dizionario \"$DizNome\" in fase di caricamento..."

	XDL_dizCarAff	$DizNome

	set	DizId  [ lindex  $AR(D,ls_Diz) end ]
	regsub	".aff\$" $DizNome  ".diz" FileDiz
	if	{ [ file  exists  $FileDiz ] == 0 } {
		XDL_messaggio	INFO  "Dizionario \"$FileDiz\" non trovato."
		return
		}

	set	pf_Diz  [ open  "$FileDiz" "r" ]
	while	{ [ gets  $pf_Diz Riga ] > -1 } {
		set	ls_Riga  [ split  "$Riga" "/" ]
		set	AR(DV,[ lindex  $ls_Riga 0 ])  [ lindex  $ls_Riga 1 ]
		}
	close	$pf_Diz

	set	NumLemmi  [ llength  [ array  names  AR "DV,*" ] ]
	if	{ $AR(D,$DizId,tipo) == "BASE" } {
		.mnu.d.m	entryconfig 0  -label "Cambia dizionario base ($AR(D,$DizId,desc))"
		XDL_messaggio	INFO  "Terminato caricamento dizionario base \"$AR(D,$DizId,desc)\" - lemmi in memoria: $NumLemmi."
	} else {
		XDL_messaggio	INFO  "Terminato caricamento integrazione al dizionario \"$AR(D,$DizId,desc)\" - lemmi in memoria: $NumLemmi."
		}
	}

#	XDL_DIZCARINT	-	CARICA UN'INTEGRAZIONE AL DIZIONARIO
#	------------------------------------------------------------------------

proc	XDL_dizCarInt {} {

	global	AR

	set	FileDiz  [ tk_getOpenFile  -parent .  -title "Nome dell'integrazione al dizionario base:" ]
	if	{ "$FileDiz" == "" } {
		return
		}

	XDL_dizCarica	$FileDiz
	}

#	XDL_DIZINFO	-	OUTPUT INFORMAZIONI SUI DIZIONARI
#	------------------------------------------------------------------------

proc	XDL_dizInfo {} {

	global	AR

	destroy	.info
	toplevel	.info
	text	.info.t  -yscrollcommand { .info.s set }
	pack	.info.t  -side left  -expand yes  -fill both
	scrollbar	.info.s  -orient vertical  -command { .info.t yview }
	pack	.info.s  -side left  -expand no  -fill y

	foreach	DizId  $AR(D,ls_Diz) {
		.info.t	insert end  "Dizionario: $DizId/$AR(D,$DizId,tipo)  $AR(D,$DizId,desc)\n            (versione: $AR(D,$DizId,vers))\n"
		}
	set	NumLemmi  [ llength  [ array  names  AR "DV,*" ] ]
	.info.t	insert end  "Numero lemmi in memoria: $NumLemmi\n\n"
	.info.t	insert end  "================================================================================\n\n"

	set	pf_Info  [ open  "info.txt" "r" ]
	.info.t	insert end  [ read  $pf_Info  10000 ]
	close	$pf_Info
	}

#	XDL_DIZTROVA	-	CERCA UNA PAROLA CON SFX o PFX NEL DIZIONARIO
#	------------------------------------------------------------------------

proc	XDL_dizTrova { Parola } {

	global	AR

	set	Finale  [ string  range  $Parola  end end ]
	if	{ [ info  exists  AR(DI,SFX,$Finale) ] == 0 } {
		return	0
		}
	foreach	IndS  $AR(DI,SFX,$Finale) {
		regsub	"$AR(DA,$IndS,E)\$" "$Parola"  "$AR(DA,$IndS,I)" NewPar
#		puts	"<<       S!! $NewPar $AR(DA,$IndS,T) $AR(DA,$IndS,E) $AR(DA,$IndS,I) >>"
		if	{ [ info  exists  AR(DV,$NewPar) ]  &&  [ string  first  "$AR(DA,$IndS,T)" $AR(DV,$NewPar) ] > -1 } {
			return	1
			}
		}
	foreach	Prefisso  $AR(DI,PFX,ls) {
		if	{ [ regsub  "^$Prefisso" $Parola  "" NewPar ] == 1 } {
			if	[ info  exists  AR(DV,$NewPar) ] {
				return	1
				}
			foreach	IndS  $AR(DI,SFX,$Finale) {
				regsub	"$AR(DA,$IndS,E)\$" "$NewPar"  "$AR(DA,$IndS,I)" NewPfx
				if	{ [ info  exists  AR(DV,$NewPfx) ]  &&  [ string  first  "$AR(DA,$IndS,T)" $AR(DV,$NewPfx) ] > -1 } {
					return	1
					}
				}
			}
		}
	return	0
	}

#	XDL_ERRANNCONF	-	ANNULLA CONFERMA ERRORE CORRENTE
#	------------------------------------------------------------------------

proc	XDL_errAnnConf {} {

	global	AR

	set	ErrNum  $AR(Current,Err)
	if	{ $AR(ERR,$ErrNum,Stato) == "M"  ||  $AR(ERR,$ErrNum,Stato) == "S" } {
		return
		}
	set	OldStato  $AR(ERR,$ErrNum,Stato)
	set	AR(ERR,$ErrNum,Stato)  "M"

	if	{ $AR(E,$AR(ERR,$ErrNum,Tipo),T) == "L" } {
		incr	AR(Lem,Er${OldStato},$AR(ERR,$ErrNum,Parola))  -1
		incr	AR(Lem,ErM,$AR(ERR,$ErrNum,Parola))
		}
	incr	AR(Tipo,Er${OldStato},$AR(ERR,$ErrNum,Tipo))  -1
	incr	AR(Tipo,ErM,$AR(ERR,$ErrNum,Tipo))
	incr	AR(ERR,Er${OldStato})  -1
	incr	AR(ERR,ErM)
	incr	AR(Par,ErM,$AR(ERR,$ErrNum,Par))
	.ert.txt.dat	tag remove  Er${OldStato}  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
	XDL_errMarca	S
	}

#	XDL_ERRCONF	-	CONFERMA GLI ERRORI MARCATI O SMARCATI
#	------------------------------------------------------------------------

proc	XDL_errConf { Opz } {

	global	AR

	XDL_messaggio	WAIT  "Attendere: conferma errori in corso..."
	set	ComLemma  $AR(Current,Lemma)
	for	{ set ErrNum 1 } { $ErrNum<=$AR(File,Err) } { incr ErrNum } {
		if	{ $AR(ERR,$ErrNum,Stato) != $Opz } {
			continue
			}
		.ert.txt.dat	tag remove  Er$Opz  0.0 end
		.ert.txt.dat	tag add  ErC  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		if	{ $Opz == "M" } {
			set	Other  "S"
		} else {
			set	Other  "M"
			}
		if	{ $AR(E,$AR(ERR,$ErrNum,Tipo),T) == "L" } {
			incr	AR(Lem,ErC,$AR(ERR,$ErrNum,Parola))
			incr	AR(Lem,Er${Opz},$AR(ERR,$ErrNum,Parola))  -2
			incr	AR(Lem,Er${Other},$AR(ERR,$ErrNum,Parola))
			XDL_lemTestMar	$AR(ERR,$ErrNum,Parola) $Opz
			}
		incr	AR(Tipo,ErC,$AR(ERR,$ErrNum,Tipo))
		incr	AR(Tipo,Er${Opz},$AR(ERR,$ErrNum,Tipo))  -2
		incr	AR(Tipo,Er${Other},$AR(ERR,$ErrNum,Tipo))
		XDL_tipTestMar	$AR(ERR,$ErrNum,Tipo) $Opz
		incr	AR(ERR,ErC)
		incr	AR(Par,Er$Opz,$AR(ERR,$ErrNum,Par))  -1
		incr	AR(ERR,Er$Opz)  -1
		set	AR(ERR,$ErrNum,Stato)  C
		if	{ $AR(Current,Par) == $AR(ERR,$ErrNum,Par) } {
			XDL_parOut	$AR(Current,Par)
			}
		if	{ $AR(ERR,$ErrNum,Tipo) == $AR(Current,Tipo) } {
			XDL_tipTop
			}
		if	{ $AR(Current,Err) == $ErrNum } {
			XDL_errOut	$ErrNum
			}
		}
	XDL_errTop
	XDL_messaggio	INFO  "Conferma errori eseguita."
	set	AR(Current,Lemma)  "$ComLemma"
	if	{ "$AR(Current,Lemma)" == "" } {
		.ler.top.ent	delete  0 end
		.ler.top.dat	delete  0.0 end
		return
		}
	XDL_lerTop
	}

#	XDL_ERRESCL	-	ESCLUSIONE DEGLI ERRORI MARCATI O SMARCATI
#	------------------------------------------------------------------------

proc	XDL_errEscl { Opz } {

	global	AR

	XDL_messaggio	WAIT  "Attendere: esclusione errori in corso..."
	set	ComLemma  $AR(Current,Lemma)
	for	{ set ErrNum 1 } { $ErrNum<=$AR(File,Err) } { incr ErrNum } {
		if	{ $AR(ERR,$ErrNum,Stato) != $Opz } {
			continue
			}
		.ert.txt.dat	tag remove  Er$Opz  0.0 end
		.ert.txt.dat	tag add  ErE  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		if	{ $Opz == "M" } {
			set	Other  "S"
		} else {
			set	Other  "M"
			}
		if	{ $AR(E,$AR(ERR,$ErrNum,Tipo),T) == "L" } {
			incr	AR(Lem,ErE,$AR(ERR,$ErrNum,Parola))
			incr	AR(Lem,Er${Opz},$AR(ERR,$ErrNum,Parola))  -2
			incr	AR(Lem,Er${Other},$AR(ERR,$ErrNum,Parola))
			XDL_lemTestMar	$AR(ERR,$ErrNum,Parola) $Opz
			}
		incr	AR(Tipo,ErE,$AR(ERR,$ErrNum,Tipo))
		incr	AR(Tipo,Er${Opz},$AR(ERR,$ErrNum,Tipo))  -2
		incr	AR(Tipo,Er${Other},$AR(ERR,$ErrNum,Tipo))
		XDL_tipTestMar	$AR(ERR,$ErrNum,Tipo) $Opz
		incr	AR(ERR,ErE)
		incr	AR(Par,Er$Opz,$AR(ERR,$ErrNum,Par))  -1
		incr	AR(ERR,Er$Opz)  -1
		set	AR(ERR,$ErrNum,Stato)  E
		if	{ $AR(Current,Par) == $AR(ERR,$ErrNum,Par) } {
			XDL_parOut	$AR(Current,Par)
			}
		if	{ $AR(ERR,$ErrNum,Tipo) == $AR(Current,Tipo) } {
			XDL_tipTop
			}
		if	{ $AR(Current,Err) == $ErrNum } {
			XDL_errOut	$ErrNum
			}
		}
	XDL_errTop
	XDL_messaggio	INFO  "Esclusione errori eseguita."
	set	AR(Current,Lemma)  "$ComLemma"
	if	{ "$AR(Current,Lemma)" == "" } {
		.ler.top.ent	delete  0 end
		.ler.top.dat	delete  0.0 end
		return
		}
	XDL_lerTop
	}

#	XDL_ERRMARCA	-	MARCA O SMARCA UN ERRORE
#	------------------------------------------------------------------------

proc	XDL_errMarca { Opz } {

	global	AR

	set	ErrNum  $AR(Current,Err)
	if	{ $AR(ERR,$ErrNum,Stato) == "C"  ||  $AR(ERR,$ErrNum,Stato) == "E" } {
		return
		}
	if	{ $Opz == "M" } {
		set	Other  "S"
	} else {
		set	Other  "M"
		}
	.ert.txt.dat	tag remove  Er$Other  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
	.ert.txt.dat	tag add  Er$Opz  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
	XDL_lemTestMar	$AR(ERR,$ErrNum,Parola) $Opz
	XDL_tipTestMar	$AR(ERR,$ErrNum,Tipo) $Opz
	if	{ $AR(ERR,$ErrNum,Parola) == $AR(Current,Lemma) } {
		XDL_lerTop
		}
	set	Par  $AR(ERR,$ErrNum,Par)
	incr	AR(Par,Er$Opz,$Par)
	incr	AR(ERR,Er$Opz)
	incr	AR(Par,Er$Other,$Par)  -1
	incr	AR(ERR,Er$Other)  -1
	set	AR(ERR,$ErrNum,Stato)  $Opz
	if	{ $AR(Current,Par) == $Par } {
		XDL_parOut	$AR(Current,Par)
		}
	if	{ $AR(ERR,$ErrNum,Tipo) == $AR(Current,Tipo) } {
		XDL_tipTop
		}
	XDL_errOut	$ErrNum
	XDL_errTop
	}

#	XDL_ERRMARSEL	-	MARCA O SMARCA GLI ERRORI SELEZIONATI
#	------------------------------------------------------------------------

proc	XDL_errMarSel { Opz } {

	global	AR

	if	{ [ .ert.txt.dat  tag ranges  sel ] == "" } {
		return
		}
	XDL_messaggio	WAIT  "Attendere: marcatura errori in corso..."
	set	ComErr  $AR(Current,Err)
	set	ErrP  [ lindex  [ split  [ .ert.txt.dat  index  "sel.first" ] "." ] 0 ]
	set	ErrU  [ lindex  [ split  [ .ert.txt.dat  index  "sel.last" ] "." ] 0 ]
	for	{ set Ce $ErrP } { $Ce<=$ErrU } { incr Ce } {
		set	AR(Current,Err)  $Ce
		XDL_errMarca	$Opz
		}
	set	AR(Current,Err)  $ComErr
	XDL_errOut	$AR(Current,Err)
	XDL_errTop
	.ert.txt.dat	tag remove  sel  0.0 end
	XDL_messaggio	INFO  "Marcatura errori terminata."
	}

#	XDL_ERROUT	-	VISUALIZZA DETTAGLI DI UN ERRORE
#	------------------------------------------------------------------------

proc	XDL_errOut { Num {Ps ""} } {

	global	AR

	if	{ $Num == "Scala" } {
		set	Num  $Ps
		set	Delta  [ expr  $Num - $AR(Current,Err) ]
		if	{ $Delta != 0 } {
			set	Segno  [ expr  $Delta / abs($Delta) ]
			set	Conf  0
			if	{ $AR(ERR,$Num,Stato) == "C"  ||  $AR(ERR,$Num,Stato) == "E" } {
				set	Conf  1
				}
			if	{ $AR(Scorri,ert) == "ERR"  &&  $Conf == 1 } {
				set	NeoNum  [ expr  $Num + $Segno ]
				if	{ $NeoNum < $AR(File,Err) } {
					.ert.sca	set  $NeoNum
					XDL_errOut	"Scala" $NeoNum
					return
					}
				}
			}
		}

	if	{ $Num == 0 } {
		return
		}
	set	AR(Current,Err)  $Num
	XDL_errTop
	.err.num	config  -text " $Num "
	.err.mnu	config  -state disabled
	switch	-glob -- $AR(ERR,$Num,Stato) {
	"C"	{	set	Stato  "CONFERMATO"
			.err.sta	config  -fg red
			.err.mnu	config  -state normal
			}
	"E"	{	set	Stato  "escluso"
			.err.sta	config  -fg black
			.err.mnu	config  -state normal
			}
	"M"	{	set	Stato  "MARCATO"
			.err.sta	config  -fg red
			}
	"S"	{	set	Stato  "non marcato"
			.err.sta	config  -fg red
			}
		}
	.err.sta	config  -text " $Stato "
	.err.tip	config  -text "$AR(E,$AR(ERR,$Num,Tipo))"
	.err.str	config  -text "$AR(ERR,$Num,Parola)"
	.err.txt	config  -text "$AR(ERR,$Num,Testo)"
	.ert.txt.dat	yview -pickplace  $Num.0
	.ert.txt.dat	tag remove  Evidenzia  0.0 end
	.ert.txt.dat	tag add  Evidenzia  "$Num.0 linestart" "$Num.0 lineend"
	XDL_parOut	$AR(ERR,$Num,Par)
	set	Lung  [ string  length  "$AR(ERR,$Num,Parola)" ]
	set	Posiz  $AR(ERR,$Num,Pos)
	.par.txt.dat	tag remove  Evidenzia  0.0 end
	.par.txt.dat	tag add  Evidenzia  1.$Posiz 1.[ expr  $Posiz + $Lung ]
	.tip.txt.dat	tag remove  Evidenzia  0.0 end
	.tip.txt.dat	tag add  Evidenzia  "T_$AR(ERR,$Num,Tipo).first" "T_$AR(ERR,$Num,Tipo).last"
	.tip.txt.dat	yview -pickplace  "T_$AR(ERR,$Num,Tipo).first"
	set	AR(Current,MarTipo)  $AR(ERR,$Num,Tipo)
	.tip.mnu.t	entryconfig "marca*"  -label "marca per tipo errore $AR(ERR,$Num,Tipo)"
	if	{ [ info  exists  AR(Lem,ErM,$AR(ERR,$Num,Parola)) ] == 1 } {
		.ler.txt.dat	yview -pickplace  "L_$AR(ERR,$Num,Parola).first"
		.ler.txt.dat	tag remove  Evidenzia  0.0 end
		.ler.txt.dat	tag add  Evidenzia  "L_$AR(ERR,$Num,Parola).first" "L_$AR(ERR,$Num,Parola).last"
		}
	.err.not.ent	delete  0 end
	if	{ [ info  exists  AR(ERR,$Num,Nota) ] == 1 } {
		.err.not.ent	insert 0  $AR(ERR,$Num,Nota)
		}
	}

#	XDL_ERRREGISTRA	-	REGISTRA IN MEMORIA UN ERRORE
#	------------------------------------------------------------------------

proc	XDL_errRegistra { Tipo Parola } {

	global	AR

	incr	AR(File,Err)
	incr	AR(Par,ErS,$AR(Par))
	lappend	AR(Par,lsE,$AR(Par))  $AR(File,Err)
	lappend	AR(Lem,lsE,$Parola)  $AR(File,Err)
	set	AR(ERR,$AR(File,Err),Tipo)  $Tipo
	set	AR(ERR,$AR(File,Err),Par)  $AR(Par)
	set	AR(ERR,$AR(File,Err),Parola)  $Parola
	set	AR(ERR,$AR(File,Err),Pos)  $AR(Pos)
	set	AR(ERR,$AR(File,Err),Stato)  "S"
	lappend	AR(Tipo,lsE,$Tipo)  $AR(File,Err)

	set	Posiz  $AR(Pos)
	set	Lung  [ string  length  "$Parola" ]
	set	RigaT  "$AR(Riga)"
	set	Ind  $Posiz
	if	{ [ string  length  "$AR(Riga)" ] > 40 } {
		set	Posiz  24
		if	{ $Ind < 20 } {
			set	Posiz  [ expr  $Ind + 4 ]
			set	Ind  20
			}
		set	RigaT  [ format  "/// %s ///" [ string  range  "$RigaT"  [ expr  $Ind - 20 ] \
										 [ expr  $Ind + 20 + $Lung ] ] ]
		}
	set	AR(ERR,$AR(File,Err),Testo)  $RigaT
	set	AR(ERR,$AR(File,Err),PosTesto)  $Posiz

	.ert.txt.dat	insert end  [ format  "%s  %54.54s  %-19.19s\n"  $Tipo $RigaT "--$Parola--" ]
	.ert.txt.dat	yview  end
	set	AR(Lem,R,$Parola)  $Tipo
	}

#	XDL_ERRSALVA	-	SALVA IL FILE CON LE INFORMAZIONI DEGLI ERRORI
#	------------------------------------------------------------------------

proc	XDL_errSalva { Opz } {

	global	AR NOMECOD RELEASE tk_version

	switch	-glob -- "$Opz" {
	"C"	{	set	Info  "Salva le informazioni degli errori confermati"
			}
	"E"	{	set	Info  "Salva le informazioni degli errori esclusi"
			}
	"M"	{	set	Info  "Salva le informazioni degli errori marcati"
			}
	"S"	{	set	Info  "Salva le informazioni degli errori smarcati"
			}
	"T"	{	set	Info  "Salva le informazioni di tutti gli errori"
			}
		}
	set	FileInt  [ tk_getSaveFile  -parent .  -title "$Info" ]
	if	{ "$FileInt" == "" } {
		return
		}
	XDL_messaggio	WAIT  "Attendere, salvataggio errori in corso..."
	set	pf_Out  [ open  $FileInt "w" ]
	puts	$pf_Out  "================================================================================\n"
	puts	$pf_Out  "Test vocaboli file $AR(Flag,NomeFile)"
	puts	$pf_Out  "paragrafi: $AR(File,Par)   lemmi: $AR(File,Parole)   caratteri testo: $AR(File,ByteTesto)\n"
	puts	$pf_Out  "con verificatore $NOMECOD (Tommaso Di Lemma)   ver: $RELEASE   tk:($tk_version)\n"
	puts	$pf_Out  "Per ulteriori informazioni contattare Dario Zanotti: dzanotti@tiscali.it\n"
	puts	$pf_Out  "--------------------------------------------------------------------------------\n"
	foreach	DizId  $AR(D,ls_Diz) {
		puts	$pf_Out  "Dizionario: $DizId/$AR(D,$DizId,tipo)  $AR(D,$DizId,desc)\n            (versione: $AR(D,$DizId,vers))\n"
		}
	set	NumLemmi  [ llength  [ array  names  AR "DV,*" ] ]
	puts	$pf_Out  "Numero lemmi in memoria: $NumLemmi\n"
	puts	$pf_Out  "--------------------------------------------------------------------------------\n"
	puts	$pf_Out  [ format  "Numero totale sospetti errori: %5d"  $AR(File,Err) ]
	puts	$pf_Out  [ format  "  (di cui attualmente marcati: %5d)"  $AR(ERR,ErM) ]
	puts	$pf_Out  [ format  "            Errori confermati: %5d"  $AR(ERR,ErC) ]
	puts	$pf_Out  "\n================================================================================\n"
	for	{ set ErrNum 1 } { $ErrNum<=$AR(File,Err) } { incr ErrNum } {
		switch	-glob -- "$Opz" {
		"C"	-
		"E"	-
		"M"	-
		"S"	{	if	{ $AR(ERR,$ErrNum,Stato) != "$Opz" } {
					continue
					}
				}
			}
		puts	$pf_Out  [ format  "%s *%4.4d*%40s : paragrafo %5d ; --%s--" \
				$AR(ERR,$ErrNum,Stato) $ErrNum $AR(E,$AR(ERR,$ErrNum,Tipo)) $AR(ERR,$ErrNum,Par) $AR(ERR,$ErrNum,Parola) ]
		puts	$pf_Out  [ format  "%s"  $AR(ERR,$ErrNum,Testo) ]
		puts	-nonewline $pf_Out  [ format  "%$AR(ERR,$ErrNum,PosTesto)s"  "" ]
		set	Lung  [ string  length  "$AR(ERR,$ErrNum,Parola)" ]
		for	{ set Cl 0 } { $Cl<$Lung } { incr Cl } {
			puts	-nonewline $pf_Out  "-"
			}
		if	{ [ info  exists  AR(ERR,$ErrNum,Nota) ] == 1  &&  $AR(ERR,$ErrNum,Nota) != "" } {
			puts	-nonewline $pf_Out  "\nN.B.   ==>   $AR(ERR,$ErrNum,Nota)   <=="
			}
		puts	$pf_Out  "\n"
		}
	close	$pf_Out
	XDL_messaggio	INFO  "Salvataggio errori su file \"$FileInt\" terminato."
	}

#	XDL_ERRTOP	-	VISUALIZZA INFORMAZIONI SUGLI ERRORI
#	------------------------------------------------------------------------

proc	XDL_errTop {} {

	global	AR

	.ert.top.dat	delete  0.0 end
	.ert.top.dat	insert end  [ format  "%45s%5d%20s%5d\n" "confermati:" $AR(ERR,ErC) "marcati:" $AR(ERR,ErM) ]
	.ert.top.dat	insert end  "errore visualizzato:" 
	.ert.top.dat	insert end  [ format  "%5d"  $AR(Current,Err) ]  Evidenzia
	.ert.top.dat	insert end  [ format  "%20s%5d (originariamente: %d)\n" \
			"errori presenti:" \
			[ expr  $AR(File,Err) - ( $AR(ERR,ErC) + $AR(ERR,ErE) ) ] \
			$AR(File,Err) ]
	.ert.top.dat	insert end  [ format  "%45s%5d%20s%5d\n" "esclusi:" $AR(ERR,ErE) "non marcati:" $AR(ERR,ErS) ]
	.ert.top.but.mar	config  -state disabled
	.ert.top.but.sma	config  -state disabled
	if	{ $AR(ERR,$AR(Current,Err),Stato) == "M" } {
		.ert.top.but.sma	config  -state normal
		}
	if	{ $AR(ERR,$AR(Current,Err),Stato) == "S" } {
		.ert.top.but.mar	config  -state normal
		}
	}

#	XDL_FONTSIZE	-	CAMBIO DELLE DIMENSIONI DELLA FONT FIXED
#	------------------------------------------------------------------------

proc	XDL_fontsize { Size } {

	global	AR

	.ert.txt.dat	config  -font [ list  Courier $Size ]
	.par.txt.dat	config  -font [ list  Courier $Size ]
	.tip.txt.dat	config  -font [ list  Courier $Size ]
	.ler.txt.dat	config  -font [ list  Courier $Size ]
	.lva.txt.dat	config  -font [ list  Courier $Size ]
	.ert.txt.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.par.txt.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.tip.txt.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.ler.txt.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.lva.txt.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.par.txt.dat	tag config  TagCode  -font [ list  Courier $Size italic ]
	.ert.top.dat	config  -font [ list  Courier $Size ]
	.par.top.dat	config  -font [ list  Courier $Size ]
	.tip.top.dat	config  -font [ list  Courier $Size ]
	.ler.top.dat	config  -font [ list  Courier $Size ]
	.lva.top.dat	config  -font [ list  Courier $Size ]
	.ert.top.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.par.top.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.tip.top.dat	tag config  Evidenzia  -font [ list  Courier $Size bold ]
	.ler.top.ent	config  -font [ list  Courier $Size bold ]
	.lva.top.ent	config  -font [ list  Courier $Size bold ]
	}

#	XDL_LEMALFA	-	VA AL PRIMO LEMMA CHE INIZIA CON UNA STRINGA
#	------------------------------------------------------------------------

proc	XDL_lemAlfa { Opz Lettera } {

	global	AR
	
	switch	-glob -- $Opz {
	"LER"	{	set	Win  .ler.txt.dat
			}
	"LVA"	{	set	Win  .lva.txt.dat
			}
		}
	set	Ind  [ $Win  search -regexp -nocase  "^$Lettera"  0.0 ]
	if	{ $Ind == "" } {
		XDL_messaggio	INFO  "Nessun lemma che inizia per \"$Lettera\" nella lista."
		return
		}
	XDL_messaggio	INFO  "Posizionamento nella lista effettuato per \"$Lettera\"."
	$Win	yview -pickplace  $Ind
	}

#	XDL_LEMPAR	-	DALLA LISTA DI UN LEMMA RESTIRUISCE IL PARAGRAFO
#	------------------------------------------------------------------------

proc	XDL_lemPar { Num } {

	global	AR

	if	{ $Num == 0 } {
		return
		}
	set	Ind  [ expr  $Num - 1 ]
	set	Parag  [ lindex  $AR(Lem,Par,$AR(Lem,Parola)) $Ind ]
	set	Lung  [ string  length  "$AR(Lem,Parola)" ]
	set	Posiz  [ lindex  $AR(Lem,Pos,$AR(Lem,Parola)) $Ind ]
	XDL_parOut	$Parag
	.par.txt.dat	tag remove  Evidenzia  0.0 end
	.par.txt.dat	tag add  Evidenzia  1.$Posiz 1.[ expr  $Posiz + $Lung ]
	.par.txt.dat	yview -pickplace  1.$Posiz
	}

#	XDL_LEMREGISTRA	-	REGISTRA IN MEMORIA UN LEMMA
#	------------------------------------------------------------------------

proc	XDL_lemRegistra { Tipo Parola } {

	global	AR

	lappend	AR(Lem,Par,$Parola)  $AR(Par)
	lappend	AR(Lem,Pos,$Parola)  $AR(Pos)
	lappend	AR(Lem,$Tipo,Parole)  $Parola
	set	AR(Lem,R,$Parola)  $Tipo
	}

#	XDL_LEMSALDIZ	-	SALVA SU FILE I LEMMI COL FORMATO DIZIONARIO
#	------------------------------------------------------------------------

proc	XDL_lemSalDiz { Tipo {Opz "T"} } {

	global	AR

	set	FileInt  [ tk_getSaveFile  -parent .  -title "Scrittura lemmi in formato dizionario" ]
	if	{ "$FileInt" == "" } {
		return
		}
	XDL_messaggio	WAIT  "Attendere: scrittura archivio \"$FileInt\" in corso..."

	set	pf_Out  [ open  $FileInt "w" ]
	switch	-exact -- $Tipo {
	"LVA"	{	set	Win  .lva.txt.dat
			}
	"LER"	{	set	Win  .ler.txt.dat
			}
		}
	set	MaxList  [ $Win  index  end ]
	for	{ set Ind 1.0 } { $Ind<$MaxList } { set Ind [ expr  $Ind + 1 ] } {
		if	{ $AR(Current,Analisi) == "FRQ" } {
			set	Lemma  [ lindex  [ string  trim  [ $Win  get  "$Ind linestart" "$Ind lineend" ] ] 2 ]
		} else {
			set	Lemma  [ lindex  [ split  [ $Win  get  "$Ind linestart" "$Ind lineend" ] " " ] 0 ]
			}
		if	{ $Tipo == "LER"  &&  $Opz != "T" } {
			switch	-glob --  $Opz {
			"C"	{	if	{ $AR(Lem,ErM,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErE,$Lemma) > 0 } {
						continue
						}
					}
			"E"	{	if	{ $AR(Lem,ErM,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErC,$Lemma) > 0 } {
						continue
						}
					}
			"M"	{	if	{ $AR(Lem,ErE,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErC,$Lemma) > 0 } {
						continue
						}
					}
				}
			}
		if	{ [ string  is upper  "$Lemma" ] == 1 } {
			set	Lemma  [ string  tolower  "$Lemma" ]
			}
		puts	$pf_Out  "$Lemma"
		}
	close	$pf_Out
	XDL_messaggio	INFO  "Scrittura archivio \"$FileInt\" in formato dizionario terminato."
	}

#	XDL_LEMSALVA	-	SALVA SU FILE I LEMMI COL FORMATO VIDEO
#	------------------------------------------------------------------------

proc	XDL_lemSalva { Tipo {Opz "T"} } {

	global	AR

	set	FileInt  [ tk_getSaveFile  -parent .  -title "Scrittura lemmi" ]
	if	{ "$FileInt" == "" } {
		return
		}
	XDL_messaggio	WAIT  "Attendere: scrittura archivio \"$FileInt\" in corso..."

	set	pf_Out  [ open  $FileInt "w" ]
	switch	-exact -- $Tipo {
	"LVA"	{	set	Win  .lva.txt.dat
			}
	"LER"	{	set	Win  .ler.txt.dat
			}
		}
	set	MaxList  [ $Win  index  end ]
	for	{ set Ind 1.0 } { $Ind<$MaxList } { set Ind [ expr  $Ind + 1 ] } {
		if	{ $Tipo == "LER"  &&  $Opz != "T" } {
			set	Lemma  [ lindex  [ split  [ $Win  get  "$Ind linestart" "$Ind lineend" ] " " ] 0 ]
			switch	-glob --  $Opz {
			"C"	{	if	{ $AR(Lem,ErM,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErE,$Lemma) > 0 } {
						continue
						}
					}
			"E"	{	if	{ $AR(Lem,ErM,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErC,$Lemma) > 0 } {
						continue
						}
					}
			"M"	{	if	{ $AR(Lem,ErE,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErC,$Lemma) > 0 } {
						continue
						}
					}
				}
			}
		puts	$pf_Out  [ $Win  get  "$Ind linestart" "$Ind lineend" ]
		}
	close	$pf_Out
	XDL_messaggio	INFO  "Scrittura archivio \"$FileInt\" terminato."
	}

#	XDL_LEMTESTMAR	-	VERIFICA STATO DI MARCATURA DI LEMMA IN ERRORE
#	------------------------------------------------------------------------

proc	XDL_lemTestMar { Parola Opz } {

	global	AR

	if	{ [ info  exists  AR(Lem,ErM,$Parola) ] == 0 } {
		return
		}
	if	{ $Opz == "M" } {
		set	Other  "S"
	} else {
		set	Other  "M"
		}
	incr	AR(Lem,Er$Opz,$Parola)
	incr	AR(Lem,Er$Other,$Parola)  -1
	set	NumLer  [ llength  $AR(Lem,Pos,$Parola) ]

	.ler.txt.dat	tag remove  ErM  "L_$Parola.first" "L_$Parola.last"
	.ler.txt.dat	tag remove  ErS  "L_$Parola.first" "L_$Parola.last"
	.ler.txt.dat	tag remove  ErC  "L_$Parola.first" "L_$Parola.last"
	.ler.txt.dat	tag remove  ErE  "L_$Parola.first" "L_$Parola.last"
	if	{ $AR(Lem,ErM,$Parola) > 0  &&  $AR(Lem,ErS,$Parola) == 0 } {
		.ler.txt.dat	tag add  ErM  "L_$Parola.first" "L_$Parola.last"
		return
		}
	if	{ $AR(Lem,ErC,$Parola) == $NumLer } {
		.ler.txt.dat	tag add  ErC  "L_$Parola.first" "L_$Parola.last"
		return
		}
	if	{ $AR(Lem,ErE,$Parola) == $NumLer } {
		.ler.txt.dat	tag add  ErE  "L_$Parola.first" "L_$Parola.last"
		return
		}
	if	{ [ expr  $AR(Lem,ErC,$Parola) + $AR(Lem,ErE,$Parola) ] == $NumLer } {
		.ler.txt.dat	tag add  ErE  "L_$Parola.first" "L_$Parola.last"
		return
		}
	.ler.txt.dat	tag add  ErS  "L_$Parola.first" "L_$Parola.last"
	}

#	XDL_LERDIZ	-	INTEGRA DIZIONARIO (RAM) CON LEMMI IN ERRORE
#	------------------------------------------------------------------------

proc	XDL_lerDiz { Opz } {

	global	AR

	XDL_messaggio	WAIT  "Attendere: integrazione dizionario in corso..."

	set	DizId  "LER"
	lappend	AR(D,ls_Diz)  "LER"
	set	MaxList  [ .ler.txt.dat  index  end ]
	for	{ set Ind 1.0 } { $Ind<$MaxList } { set Ind [ expr  $Ind + 1 ] } {
		set	Lemma  [ lindex  [ split  [ .ler.txt.dat  get  "$Ind linestart" "$Ind lineend" ] " " ] 0 ]
		switch	-glob --  $Opz {
		"E"	{	if	{ $AR(Lem,ErM,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErC,$Lemma) > 0 } {
					continue
					}
				}
		"M"	{	if	{ $AR(Lem,ErE,$Lemma) > 0  ||  $AR(Lem,ErS,$Lemma) > 0  ||  $AR(Lem,ErC,$Lemma) > 0 } {
					continue
					}
				}
			}
		set	AR(DV,$Lemma)  ""
		}

	set	NumLemmi  [ llength  [ array  names  AR "DV,*" ] ]
	XDL_messaggio	INFO  "Terminato caricamento integrazione al dizionario - lemmi in memoria: $NumLemmi."
	}

#	XDL_LERMARCA	-	MARCA O SMARCA UN LEMMA IN ERRORE
#	------------------------------------------------------------------------

proc	XDL_lerMarca { Opz } {

	global	AR

	for	{ set ErrNum 1 } { $ErrNum<=$AR(File,Err) } { incr ErrNum } {
		if	{ $AR(ERR,$ErrNum,Parola) != $AR(Current,Lemma) } {
			continue
			}
		if	{ $Opz == "M" } {
			set	Other  "S"
		} else {
			set	Other  "M"
			}
		if	{ $AR(ERR,$ErrNum,Stato) != $Other } {
			continue
			}
		.ert.txt.dat	tag remove  Er$Other  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		.ert.txt.dat	tag add  Er$Opz  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		XDL_lemTestMar	$AR(ERR,$ErrNum,Parola) $Opz
		XDL_tipTestMar	$AR(ERR,$ErrNum,Tipo) $Opz
		incr	AR(Par,Er$Opz,$AR(ERR,$ErrNum,Par))
		incr	AR(ERR,Er$Opz)
		incr	AR(Par,Er$Other,$AR(ERR,$ErrNum,Par))  -1
		incr	AR(ERR,Er$Other)  -1
		set	AR(ERR,$ErrNum,Stato)  $Opz
		if	{ $AR(Current,Par) == $AR(ERR,$ErrNum,Par) } {
			XDL_parOut	$AR(Current,Par)
			}
		if	{ $AR(ERR,$ErrNum,Tipo) == $AR(Current,Tipo) } {
			XDL_tipTop
			}
		}
	XDL_errTop
	.ler.txt.dat	tag remove  sel  0.0 end
	if	{ "$AR(Current,Lemma)" == "" } {
		return
		}
	XDL_lerTop
	}

#	XDL_LERMARSEL	-	MARCA I LEMMI IN ERRORE SELEZIONATI
#	------------------------------------------------------------------------

proc	XDL_lerMarSel { Opz } {

	global	AR

	if	{ [ .ler.txt.dat  tag ranges  sel ] == "" } {
		return
		}
	XDL_messaggio	WAIT  "Attendere: marcatura lemmi in corso..."
	set	ComLemma  $AR(Current,Lemma)
	foreach	Item  [ split  [ .ler.txt.dat  get  "sel.first linestart" "sel.last lineend" ] "\n" ] {
		set	AR(Current,Lemma)  [ lindex  [ split  "$Item" ] 0 ]
		XDL_lerMarca	$Opz
		}
	XDL_messaggio	INFO  "Marcatura eseguita."
	set	AR(Current,Lemma)  "$ComLemma"
	if	{ "$AR(Current,Lemma)" == "" } {
		.ler.top.ent	delete  0 end
		.ler.top.dat	delete  0.0 end
		return
		}
	XDL_lerTop
	}

#	XDL_LERMARTUTTI	-	MARCA O SMARCA TUTTI I LEMMI IN ERRORE
#	------------------------------------------------------------------------

proc	XDL_lerMarTutti { Opz Volte } {

	global	AR

	XDL_messaggio	WAIT  "Attendere: marcatura lemmi in corso..."
	set	ComLemma  $AR(Current,Lemma)
	foreach	Item  [ split  [ .ler.txt.dat  get  1.0 "end - 1 char" ] "\n" ] {
		set	AR(Current,Lemma)  [ lindex  [ split  "$Item" ] 0 ]
		set	Ricorrenza  [ string  trimleft  [ lindex  [ split  "$Item" "()" ] 1 ] ]
		if	{ $Opz == "M"  &&  $Ricorrenza < $Volte } {
			continue
			}
		XDL_lerMarca	$Opz
		}
	XDL_messaggio	INFO  "Marcatura eseguita."
	set	AR(Current,Lemma)  "$ComLemma"
	if	{ "$AR(Current,Lemma)" == "" } {
		.ler.top.ent	delete  0 end
		.ler.top.dat	delete  0.0 end
		return
		}
	XDL_lerTop
	}

#	XDL_LERPAR	-	DALLA LISTA DI UN LEMMA IN ERRORE
#	------------------------------------------------------------------------

proc	XDL_lerPar { Num {Ps ""} } {

	global	AR

	if	{ $Num == "Scala" } {
		set	Num  $Ps
		set	Delta  [ expr  $Num - $AR(Current,Ler) ]
		if	{ $Delta != 0 } {
			set	Segno  [ expr  $Delta / abs($Delta) ]
			set	Conf  0
			set	NumErr  [ lindex  $AR(Lem,lsE,$AR(Lem,Parola)) [ expr  $Num - 1 ] ]
			if	{ $AR(ERR,$NumErr,Stato) == "C"  ||  $AR(ERR,$NumErr,Stato) == "E" } {
				set	Conf  1
				}
			if	{ $AR(Scorri,ler) == "ERR"  &&  $Conf == 1 } {
				set	NeoNum  [ expr  $Num + $Segno ]
				if	{ $NeoNum <= [ llength  $AR(Lem,lsE,$AR(Lem,Parola)) ]  &&  $NeoNum > 0 } {
					.ler.sca	set  $NeoNum
					XDL_lerPar	"Scala" $NeoNum
					return
					}
				}
			}
		}
	if	{ $Num == 0 } {
		return
		}
	XDL_lemPar	$Num
	set	AR(Current,Ler)  $Num
	set	Ind  [ expr  $Num - 1 ]
	set	Par  [ lindex  $AR(Lem,Par,$AR(Lem,Parola)) $Ind ]
	if	[ info  exists  AR(Lem,lsE,$AR(Lem,Parola)) ] {
		XDL_errOut	[ lindex  $AR(Lem,lsE,$AR(Lem,Parola)) $Ind ]
		}
	}

#	XDL_LERTOP	-	VISUALIZZA INFORMAZIONI SUL LEMMA IN ERRORE
#	------------------------------------------------------------------------

proc	XDL_lerTop {} {

	global	AR
	
	.ler.top.ent	delete  0 end
	.ler.top.dat	delete  0.0 end
	.ler.top.ent	insert end  "$AR(Current,Lemma)"
	.ler.top.dat	insert end  [ format  "%20s\n" "marcati: $AR(Lem,ErM,$AR(Current,Lemma))" ]
	.ler.top.dat	insert end  [ format  "%20s" "non marcati: $AR(Lem,ErS,$AR(Current,Lemma))" ]
	.ler.top.but.mar	config  -state disabled
	.ler.top.but.sma	config  -state disabled
	if	{ $AR(Lem,ErM,$AR(Current,Lemma)) > 0 } {
		.ler.top.but.sma	config  -state normal
		}
	if	{ $AR(Lem,ErS,$AR(Current,Lemma)) > 0 } {
		.ler.top.but.mar	config  -state normal
		}
	}

#	XDL_MESSAGGIO	-	VISUALIZZA MESSAGGIO NELLA FASCIA IN BASSO
#	------------------------------------------------------------------------

proc	XDL_messaggio { Tipo Messaggio } {

	switch	-exact -- $Tipo {
	"WAIT"	{	.msg	config  -fg white  -bg red  -bitmap hourglass  -text "   $Messaggio"
			update
			}
	"INFO"	{	.msg	config  -fg black  -bg white  -bitmap info  -text "   $Messaggio"
			}
		}
	}

#	XDL_NORMLISTA	-	NORMALIZZA LISTA VOCABOLI PER SORT ALFABETICO
#	------------------------------------------------------------------------

proc	XDL_normlista { ls_Voc } {

	foreach	Parola  $ls_Voc {
		set	Norm  [ string  map  {	""	"A"
						""	"A"
						""	"A"
						""	"A"
						""	"A"
						""	"A"
						""	"A"
						""	"C"
						""	"E"
						""	"E"
						""	"E"
						""	"E"
						""	"I"
						""	"I"
						""	"I"
						""	"I"
						""	"D"
						""	"N"
						""	"O"
						""	"O"
						""	"O"
						""	"O"
						""	"O"
						""	"O"
						""	"U"
						""	"U"
						""	"U"
						""	"U"
						""	"Y"
						""	"ss"
						""	"a"
						""	"a"
						""	"a"
						""	"a"
						""	"a"
						""	"a"
						""	"a"
						""	"c"
						""	"e"
						""	"e"
						""	"e"
						""	"e"
						""	"i"
						""	"i"
						""	"i"
						""	"i"
						""	"d"
						""	"n"
						""	"o"
						""	"o"
						""	"o"
						""	"o"
						""	"o"
						""	"o"
						""	"u"
						""	"u"
						""	"u"
						""	"u"
						""	"y"
						""	"y"
						}  "$Parola" ]	
		lappend	ls_Norm  [ list  $Parola $Norm ]
		}

	return	$ls_Norm
	}

#	XDL_PARBLINK	-	FA LAMPEGGIARE IL LEMMA NEL PARAGRAFO
#	------------------------------------------------------------------------

proc	XDL_parBlink { Option } {

	global	AR

	.par.txt.dat	tag config  Evidenzia  -relief $Option
	if	{ $Option == "raised" } {
		after	500  { XDL_parBlink  flat }
	} else {
		after	500  { XDL_parBlink  raised }
		}
	}

#	XDL_PARMARCA	-	MARCA O SMARCA GLI ERRORI IN UN PARAGRAFO
#	------------------------------------------------------------------------

proc	XDL_parMarca { Opz } {

	global	AR

	foreach	ErrNum  $AR(Par,lsE,$AR(Current,Par)) {
		if	{ $Opz == "M" } {
			set	Other  "S"
		} else {
			set	Other  "M"
			}
		if	{ $AR(ERR,$ErrNum,Stato) != $Other } {
			continue
			}
		.ert.txt.dat	tag remove  Er$Other  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		.ert.txt.dat	tag add  Er$Opz  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		XDL_lemTestMar	$AR(ERR,$ErrNum,Parola) $Opz
		XDL_tipTestMar	$AR(ERR,$ErrNum,Tipo) $Opz
		if	{ $AR(ERR,$ErrNum,Parola) == $AR(Current,Lemma) } {
			XDL_lerTop
			}
		if	{ $AR(ERR,$ErrNum,Tipo) == $AR(Current,Tipo) } {
			XDL_tipTop
			}
		incr	AR(Par,Er$Opz,$AR(Current,Par))
		incr	AR(ERR,Er$Opz)
		incr	AR(Par,Er$Other,$AR(Current,Par))  -1
		incr	AR(ERR,Er$Other)  -1
		set	AR(ERR,$ErrNum,Stato)  $Opz
		}
	XDL_parOut	$AR(Current,Par)
	XDL_errTop
	}

#	XDL_PAROUT	-	VISUALIZZA A VIDEO UN PARAGRAFO
#	------------------------------------------------------------------------

proc	XDL_parOut { Par {Ps ""} } {

	global	AR

	if	{ $Par == "Scala" } {
		set	Par  $Ps
		set	Delta  [ expr  $Par - $AR(Current,Par) ]
		if	{ $Delta != 0 } {
			set	Segno  [ expr  $Delta / abs($Delta) ]
			set	Conf  0
			foreach	NumErr  $AR(Par,lsE,$Par) {
				if	{ $AR(ERR,$NumErr,Stato) == "C"  ||  $AR(ERR,$NumErr,Stato) == "E" } {
					incr	Conf
					}
				}
			if	{ $AR(Scorri,par) == "ERR"  &&  [ llength  $AR(Par,lsE,$Par) ] == $Conf } {
				set	NeoPar  [ expr  $Par + $Segno ]
				if	{ $NeoPar < $AR(File,Par) } {
					.par.sca	set  $NeoPar
					XDL_parOut	"Scala" $NeoPar
					return
					}
				}
			}
		}
	if	{ $Par == 0 } {
		return
		}
	set	AR(Current,Par)  $Par
	.par.txt.dat	delete  0.0 end
	.par.top.but.mar	config  -state disabled
	.par.top.but.sma	config  -state disabled
	set	ParSeek  [ expr  $Par - 1 ]
	seek	$AR(File,PF)  $AR(Par,Pos,$ParSeek)
	gets	$AR(File,PF)  Riga
	set	Riga  [ string  trim  "$Riga" ]
	regsub	-all "\t" "$Riga"  " " NewRiga
	if	{ $AR(File,Tag) } {
		set	RigaTag  "$NewRiga"
		set	NewRiga  [ XDL_tagElim  "$NewRiga" ]
		}
	.par.txt.dat	insert end  "$NewRiga"
	if	{ $AR(File,Tag) } {
		.par.txt.dat	insert end  "\n\n$RigaTag" TagCode
		}

	set	ParErr  [ expr  $AR(Par,ErM,$Par) + $AR(Par,ErS,$Par) ]
	.par.top.dat	delete  0.0 end
	if	{ $ParErr == 0 } {
		.par.top.dat	insert end  "\nvisualizzato paragrafo n. "
		.par.top.dat	insert end  "$Par" Evidenzia
		.par.top.dat	insert end  " di $AR(File,Par)"
		return
		}
	.par.top.dat	insert end  [ format  "%80s\n" "marcati: $AR(Par,ErM,$Par)" ]
	.par.top.dat	insert end  "visualizzato paragrafo n. "
	.par.top.dat	insert end  "$Par" Evidenzia
	.par.top.dat	insert end  " di $AR(File,Par)  errori presenti: $ParErr\n"
	.par.top.dat	insert end  [ format  "%80s\n" "non marcati: $AR(Par,ErS,$Par)" ]
	foreach	ErrNum  $AR(Par,lsE,$Par) {
		set	PosI  $AR(ERR,$ErrNum,Pos)
		set	PosE  [ expr  $PosI + [ string  length  "$AR(ERR,$ErrNum,Parola)" ] ]
		.par.txt.dat	tag add  Er$AR(ERR,$ErrNum,Stato)  1.$PosI 1.$PosE
		}
	if	{ $AR(Par,ErM,$Par) > 0 } {
		.par.top.but.sma	config  -state normal
		}
	if	{ $AR(Par,ErS,$Par) > 0 } {
		.par.top.but.mar	config  -state normal
		}
	}

#	XDL_PARSALVA	-	SALVATAGGIO SU FILE DEL PARAGRAFO CORRENTE
#	------------------------------------------------------------------------

proc	XDL_parSalva {} {

	global	AR

	set	FileInt  [ tk_getSaveFile  -parent .  -title "$Info" ]
	if	{ "$FileInt" == "" } {
		return
		}
	XDL_messaggio	WAIT  "Attendere, salvataggio paragrafo in corso..."
	
	set	pf_Out  [ open  $FileInt "w" ]
	puts	$pf_Out  [ .par.txt.dat  get  0.0 end ]
	close	$pf_Out
	XDL_messaggio	INFO  "Salvataggio paragrafo su file \"$FileInt\" terminato."
	}

#	XDL_SCORRI	-	FA SCORRERE SOLO ERRORI O TUTTO
#	------------------------------------------------------------------------

proc	XDL_Scorri { Opz } {

	global	AR

	if	{ $AR(Scorri,$Opz) == "ALL" } {
		.$Opz.mnu.t	entryconfig "Scorri *"  -label "Scorri tutto"
		set	AR(Scorri,$Opz)  "ERR"
		.$Opz.sca	config  -fg red
	} else {
		.$Opz.mnu.t	entryconfig "Scorri *"  -label "Scorri solo errori presenti"
		set	AR(Scorri,$Opz)  "ALL"
		.$Opz.sca	config  -fg black
		}
	}

#	XDL_TAGELIM	-	ELIMINA TAG <> E LORO CONTENUTO DA UNA RIGA
#	------------------------------------------------------------------------

proc	XDL_tagElim { Riga } {

	global	AR

	set	NewRiga  ""
	set	Lung  [ string  length  "$Riga" ]
	for	{ set Ct 0 } { $Ct<$Lung } { incr Ct } {
		set	Car  [ string  range  "$Riga"  $Ct $Ct ]
		switch	-exact -- $Car {
		"<"	{	set	AR(Current,Tag)  1
				}
		">"	{	set	AR(Current,Tag)  0
				}
		default	{	if	{ $AR(Current,Tag) == 0 } {
					append	NewRiga  "$Car"
					}
				}
			}
		}
	return	[ string  map  {	"&quot;"	"\""
					"&amp;"		"&"
					"&lt;"		"<"
					"&gt;"		">"
					"&nbsp;"	" "
					"&iexcl;"	""
					"&curren;"	""
					"&cent;"	""
					"&pound;"	""
					"&yen;"		""
					"&brvbar;"	""
					"&sect;"	""
					"&uml;"		""
					"&copy;"	""
					"&ordf;"	""
					"&laquo;"	""
					"&not;"		""
					"&shy;"		""
					"&reg;"		""
					"&macr;"	""
					"&deg;"		""
					"&plusmn;"	""
					"&sup2;"	""
					"&sup3;"	""
					"&micro;"	""
					"&para;"	""
					"&middot;"	""
					"&cedil;"	""
					"&sup1;"	""
					"&ordm;"	""
					"&raquo;"	""
					"&frac14;"	""
					"&frac12;"	""
					"&frac34;"	""
					"&iquest;"	""
					"&times;"	""
					"&divide;"	""
					"&Agrave;"	""
					"&Aacute;"	""
					"&Acirc;"	""
					"&Atilde;"	""
					"&Auml;"	""
					"&Aring;"	""
					"&AElig;"	""
					"&Ccedil;"	""
					"&Egrave;"	""
					"&Eacute;"	""
					"&Ecirc;"	""
					"&Euml;"	""
					"&Igrave;"	""
					"&Iacute;"	""
					"&Icirc;"	""
					"&Iuml;"	""
					"&ETH;"		""
					"&Ntilde;"	""
					"&Ograve;"	""
					"&Oacute;"	""
					"&Ocirc;"	""
					"&Otilde;"	""
					"&Ouml;"	""
					"&Oslash;"	""
					"&Ugrave;"	""
					"&Uacute;"	""
					"&Ucirc;"	""
					"&Uuml;"	""
					"&Yacute;"	""
					"&THORN;"	""
					"&szlig;"	""
					"&agrave;"	""
					"&aacute;"	""
					"&acirc;"	""
					"&atilde;"	""
					"&auml;"	""
					"&aring;"	""
					"&aelig;"	""
					"&ccedil;"	""
					"&egrave;"	""
					"&eacute;"	""
					"&ecirc;"	""
					"&euml;"	""
					"&igrave;"	""
					"&iacute;"	""
					"&icirc;"	""
					"&iuml;"	""
					"&eth;"		""
					"&ntilde;"	""
					"&ograve;"	""
					"&oacute;"	""
					"&ocirc;"	""
					"&otilde;"	""
					"&ouml;"	""
					"&oslash;"	""
					"&ugrave;"	""
					"&uacute;"	""
					"&ucirc;"	""
					"&uuml;"	""
					"&yacute;"	""
					"&thorn;"	""
					"&yuml;"	""
					"&circ;"	"^"
					"&tilde;"	"~"
					"&lsquo;"	"`"
					"&rsquo;"	"'"
					"&sbquo;"	","
					"&ldquo;"	"\""
					"&rdquo;"	"\""
					"&lsaquo;"	"<"
					"&rsaquo;"	">"
					}  "$NewRiga" ]
	}

#	XDL_TESTOCAR	-	CARICA IN MEMORIA INFORMAZIONI SUL TESTO
#	------------------------------------------------------------------------

proc	XDL_testoCar {} {

	global	AR

	XDL_widDisatt	TCAR

	if	{ "$AR(Flag,NomeFile)" == "" } {
		set	AR(Flag,NomeFile)  [ tk_getOpenFile  -parent .  -title "Carica un file di testo" ]
		if	{ "$AR(Flag,NomeFile)" == "" } {
			return
			}
		}
	if	{ [ file  readable  "$AR(Flag,NomeFile)" ] == 0 } {
		.msg	config  -bitmap error  -text "   Testo $AR(Flag,NomeFile) non leggibile"
		return
		}
	XDL_messaggio	WAIT  "Attendere: caricamento testo..."

	set	AR(File,PF)  [ open  "$AR(Flag,NomeFile)" "r" ]
	set	AR(Par,Pos,$AR(File,Par))  [ tell $AR(File,PF) ]
	set	AR(Par,ErM,$AR(File,Par))  0
	set	AR(Par,ErS,$AR(File,Par))  0
	while	{ [ gets  $AR(File,PF) Riga ] > -1 } {
		incr	AR(File,Par)
		incr	AR(File,Parole)  [ llength  [ split  "$Riga" " ,.?!-=;:()\"\&\[\]<>/'%" ] ]
		incr	AR(File,ByteTesto)  [ string  length  "$Riga" ]
		.msg	config  -text "   Testo $AR(Flag,NomeFile)  paragrafi: $AR(File,Par)  lemmi: $AR(File,Parole)  caratteri: $AR(File,ByteTesto)"
		update
		set	AR(Par,Pos,$AR(File,Par))  [ tell $AR(File,PF) ]
		set	AR(Par,lsE,$AR(File,Par))  {}
		set	AR(Par,ErM,$AR(File,Par))  0
		set	AR(Par,ErS,$AR(File,Par))  0
		}

	.par.sca	config  -from 1  -to $AR(File,Par)  -tickinterval [ expr  $AR(File,Par) - 1 ]  -command { XDL_parOut Scala }
	.par.sca	set  1
	XDL_parOut	1

	XDL_widAttiva	TCAR

	XDL_messaggio	INFO  "Caricamento testo $AR(Flag,NomeFile) terminato:  paragrafi: $AR(File,Par)  parole: $AR(File,Parole)  caratteri: $AR(File,ByteTesto)"
	}

#	XDL_TESTOERR	-	CERCA I SOSPETTI ERRORI NEL TESTO
#	------------------------------------------------------------------------

proc	XDL_testoErr {} {

	global	AR

	XDL_widDisatt	TERR

	XDL_messaggio	WAIT  "Attendere: analisi sospetti errori nel testo in corso..."
	seek	$AR(File,PF)  0
	while	{ [ gets  $AR(File,PF) Riga ] > -1 } {
		incr	AR(Par)
		set	Riga  [ string  trim  "$Riga" ]
		regsub	-all "\t" "$Riga"  " " AR(Riga)
		if	{ $AR(File,Tag) } {
			set	AR(Riga)  [ XDL_tagElim  "$AR(Riga)" ]
			}
		.par.sca	set  $AR(Par)
		update

		set	AR(Pos)  0
		foreach	Parola  [ split  "$AR(Riga)" " ,.?!-=;:()\"\&\[\]<>/'%" ] {
			if	{ [ string  length  "$Parola" ] == 0 } {
				continue
				}
			set	AR(Pos)  [ string  first  "$Parola" "$AR(Riga)"  $AR(Pos) ]
			if	{ [ string  length  "$Parola" ] > 1 } {
				XDL_ckLemma	$Parola
				}
			set	AR(Pos)  [ expr  $AR(Pos) + [ string  length  "$Parola" ] ]
			}
		XDL_ckPar
		}
	.ert.txt.dat	delete  "end - 1 char"
	set	AR(Lem,LB,OK,Parole)  [ lsort  -unique  $AR(Lem,OK,Parole) ]
	set	ls_Util  [ XDL_normlista  $AR(Lem,LB,OK,Parole) ]
	foreach	ls_Elem  [ lsort  -index 1 -dictionary  $ls_Util ] {
		set	Parola  [ lindex  $ls_Elem 0 ]
		set	Elem  [ format  "%-18s (%4d)"  $Parola  [ llength  $AR(Lem,Pos,$Parola) ] ]
		.lva.txt.dat	insert end  "$Elem\n"
		}
	.lva.txt.dat	delete  "end - 1 char"
	set	AR(Lem,LB,NO,Parole)  [ lsort  -unique  $AR(Lem,NO,Parole) ]
	set	ls_Util  [ XDL_normlista  $AR(Lem,LB,NO,Parole) ]
	foreach	ls_Elem  [ lsort  -index 1 -dictionary  $ls_Util ] {
		set	Parola  [ lindex  $ls_Elem 0 ]
		set	Elem  [ format  "%-18s (%4d)"  $Parola  [ llength  $AR(Lem,Pos,$Parola) ] ]
		set	AR(Lem,ErC,$Parola)  0
		set	AR(Lem,ErE,$Parola)  0
		set	AR(Lem,ErM,$Parola)  0
		set	AR(Lem,ErS,$Parola)  [ llength  $AR(Lem,Pos,$Parola) ]
		.ler.txt.dat	insert end  "$Elem\n"  [ list  L_$Parola ]
		}
	.ler.txt.dat	delete  "end - 1 char"
	.ler.txt.dat	tag add  ErS  0.0 end

	foreach	Item  [ lsort  [ array  names AR  "E,*,T" ] ] {
		set	Tipo  [ lindex  [ split  $Item , ] 1 ]
		if	{ [ info  exists  AR(Tipo,lsE,$Tipo) ] == 0 } {
			continue
			}
		set	AR(Tipo,ErC,$Tipo)  0
		set	AR(Tipo,ErE,$Tipo)  0
		set	AR(Tipo,ErM,$Tipo)  0
		set	AR(Tipo,ErS,$Tipo)  [ llength  $AR(Tipo,lsE,$Tipo) ]
		set	Elem  [ format  "%s: %-15.15s %4d"  $Tipo $AR(E,$Tipo) [ llength  $AR(Tipo,lsE,$Tipo) ] ]
		.tip.txt.dat	insert end  "$Elem\n"  T_$Tipo
		}
	.tip.txt.dat	delete  "end - 1 char"
	.tip.txt.dat	tag add  ErS  0.0 end

	XDL_messaggio	INFO  "Ricerca dei sospetti errori nel testo terminata."
	if	{ $AR(File,Err) > 0 } {
		set	AR(ERR,ErS)  $AR(File,Err)
		.ert.sca	config  -from 1  -to $AR(File,Err)  -tickinterval [ expr  $AR(File,Err) - 1 ]  -command { XDL_errOut Scala }
		.ert.sca	set  1
		XDL_errOut	1
		.par.sca	set  1
		.ert.txt.dat	tag add  ErS  0.0 end
		}
	XDL_errTop
	set	AR(Current,Analisi)  ERR

	XDL_widAttiva	TERR
	}

#	XDL_TESTOLEM	-	ANALIZZA I LEMMI PRESENTI NEL TESTO
#	------------------------------------------------------------------------

proc	XDL_testoLem { Opz } {

	global	AR

	XDL_widDisatt	TLEM

	XDL_messaggio	WAIT  "Attendere: analisi testo in corso..."
	seek	$AR(File,PF)  0
	while	{ [ gets  $AR(File,PF) Riga ] > -1 } {
		incr	AR(Par)
		set	Riga  [ string  trim  "$Riga" ]
		regsub	-all "\t" "$Riga"  " " NewRiga
		if	{ $AR(File,Tag) } {
			set	NewRiga  [ XDL_tagElim  "$NewRiga" ]
			}
		.par.sca	set  $AR(Par)
		update

		set	AR(Pos)  0
		foreach	Parola  [ split  "$NewRiga" " ,.?!-=;:()\"\&\[\]<>/'%" ] {
			if	{ [ string  length  "$Parola" ] == 0 } {
				continue
				}
			set	AR(Pos)  [ string  first  "$Parola" "$NewRiga"  $AR(Pos) ]
			XDL_lemRegistra  OK  [ string  toupper  $Parola ]
			set	AR(Pos)  [ expr  $AR(Pos) + [ string  length  "$Parola" ] ]
			}
		}

	set	AR(Lem,LB,OK,Parole)  [ lsort  -unique  $AR(Lem,OK,Parole) ]
	set	ls_Util  {}
	foreach	Parola  $AR(Lem,LB,OK,Parole) {
		if	{ $Opz == "U" } {
			lappend	ls_Util  [ format  "%4d - %-18s"  [ llength  $AR(Lem,Pos,$Parola) ] $Parola ]
			}
		}
	if	{ $Opz == "U" } {
		foreach	Elem  [ lsort  -decreasing  $ls_Util ] {
			.lva.txt.dat	insert end  "$Elem\n"
			}
		set	AR(Current,Analisi)  FRQ
		XDL_messaggio	INFO  "Analisi frequenza parole testo terminata."
	} else {
		set	ls_Util  [ XDL_normlista  $AR(Lem,LB,OK,Parole) ]
		foreach	ls_Elem  [ lsort  -index 1 -dictionary  $ls_Util ] {
			set	Parola  [ lindex  $ls_Elem 0 ]
			set	Elem  [ format  "%-18s (%4d)"  $Parola  [ llength  $AR(Lem,Pos,$Parola) ] ]
			.lva.txt.dat	insert end  "$Elem\n"
			}
		set	AR(Current,Analisi)  LEM
		XDL_messaggio	INFO  "Analisi parole testo terminata."
		}
	.lva.txt.dat	delete  "end - 1 char"

	XDL_widAttiva	TLEM

	.par.sca	set  1
	XDL_parOut	1
	}

#	XDL_TESTOINFO	-	VISUALIZZA INFORMAZIONI SUL TESTO CORRENTE
#	------------------------------------------------------------------------

proc	XDL_testoInfo {} {

	global	AR

	destroy	.info
	toplevel	.info
	text	.info.t  -yscrollcommand { .info.s set }
	pack	.info.t  -side left  -expand yes  -fill both
	scrollbar	.info.s  -orient vertical  -command { .info.t yview }
	pack	.info.s  -side left  -expand no  -fill y

	.info.t	insert end  "Testo caricato: $AR(Flag,NomeFile)\n\n"
	.info.t	insert end  [ format  "Numero paragrafi:%8d\n" $AR(File,Par) ]
	.info.t	insert end  [ format  "Numero lemmi ...:%8d\n" $AR(File,Parole) ]
	.info.t	insert end  [ format  "Numero caratteri:%8d\n" $AR(File,ByteTesto) ]
	}

#	XDL_TESTONOM	-	TROVA PRESUNTI NOMI PROPRI NEL TESTO
#	------------------------------------------------------------------------

proc	XDL_testoNom {} {

	global	AR

	XDL_widDisatt	TLEM

	XDL_messaggio	WAIT  "Attendere: analisi testo in corso (ricerca possibili nomi propri)..."
	seek	$AR(File,PF)  0
	while	{ [ gets  $AR(File,PF) Riga ] > -1 } {
		incr	AR(Par)
		set	Riga  [ string  trim  "$Riga" ]
		regsub	-all "\t" "$Riga"  " " NewRiga
		if	{ $AR(File,Tag) } {
			set	NewRiga  [ XDL_tagElim  "$NewRiga" ]
			}
		.par.sca	set  $AR(Par)
		update

		set	AR(Pos)  0
		foreach	Frase  [ split  "$NewRiga" ".?!-=()\"\[\]<>" ] {
			set	Prima  0
			foreach	Parola  [ split  [ string  trim "$Frase" ] " ,;:\&/'%" ] {
				incr	Prima
				if	{ [ string  length  "$Parola" ] < 2 } {
					continue
					}
				if	{ [ string  is low  "$Parola" ] == 1 } {
					continue
					}
				if	{ [ string  is upper  "$Parola" ] == 1  &&  [ regexp  "^\[MDCLXVI\]+\$" "$Parola" ] == 1 } {
					continue
					}
				set	Iniz  [ string  range  "$Parola"  0 0 ]
				set	NoIniz  [ string  range  "$Parola"  1 end ]
				if	{ [ string  is upper  "$Iniz" ] == 0 } {
					continue
					}
				if	{ [ string  is upper  "$NoIniz" ] == 1 } {
					set	NoIniz  [ string  tolower  "$NoIniz" ]
					if	{ [ info  exists  AR(DV,[ string  tolower  "$Parola" ]) ] == 1  &&  [ info  exists  AR(DV,$Iniz$NoIniz) ] == 0 } {
						continue
						}
					if	{ [ XDL_dizTrova  [ string  tolower  "$Parola" ] ] == 1  &&  [ XDL_dizTrova  "$Iniz$NoIniz" ] == 0 } {
						continue
						}
					}
				if	{ [ string  is low  "$NoIniz" ] == 0 } {
					continue
					}
				if	{ $Prima == 1  &&  [ info  exists  AR(DV,[ string  tolower  "$Parola" ]) ] == 1  &&  [ info  exists  AR(DV,$Iniz$NoIniz) ] == 0 } {
					continue
					}
				if	{ $Prima == 1  &&  [ XDL_dizTrova  [ string  tolower  "$Parola" ] ] == 1  &&  [ XDL_dizTrova  "$Iniz$NoIniz" ] == 0 } {
					continue
					}
				set	AR(Pos)  [ string  first  "$Parola" "$NewRiga"  $AR(Pos) ]
				XDL_lemRegistra  OK  $Parola
				set	AR(Pos)  [ expr  $AR(Pos) + [ string  length  "$Parola" ] ]
				}
			}
		}

	set	AR(Lem,LB,OK,Parole)  [ lsort  -unique  $AR(Lem,OK,Parole) ]
	set	ls_Util  [ XDL_normlista  $AR(Lem,LB,OK,Parole) ]
	foreach	ls_Elem  [ lsort  -index 1 -dictionary  $ls_Util ] {
		set	Parola  [ lindex  $ls_Elem 0 ]
		set	Elem  [ format  "%-19s (%3d)"  $Parola  [ llength  $AR(Lem,Pos,$Parola) ] ]
		.lva.txt.dat	insert end  "$Elem\n"
		}
	.lva.txt.dat	delete  "end - 1 char"
	XDL_messaggio	INFO  "Analisi nomi propri testo terminata."

	XDL_widAttiva	TLEM
	set	AR(Current,Analisi)  NOM

	.par.sca	set  1
	XDL_parOut	1
	}

#	XDL_TIPMARCA	-	MARCA O SMARCA UN TIPO DI ERRORE
#	------------------------------------------------------------------------

proc	XDL_tipMarca { Opz } {

	global	AR

	foreach	ErrNum  $AR(Tipo,lsE,$AR(Current,MarTipo)) {
		if	{ $Opz == "M" } {
			set	Other  "S"
		} else {
			set	Other  "M"
			}
		if	{ $AR(ERR,$ErrNum,Stato) != $Other } {
			continue
			}
		.ert.txt.dat	tag remove  Er$Other  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		.ert.txt.dat	tag add  Er$Opz  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		XDL_lemTestMar	$AR(ERR,$ErrNum,Parola) $Opz
		XDL_tipTestMar	$AR(ERR,$ErrNum,Tipo) $Opz
		incr	AR(Par,Er$Opz,$AR(ERR,$ErrNum,Par))
		incr	AR(ERR,Er$Opz)
		incr	AR(Par,Er$Other,$AR(ERR,$ErrNum,Par))  -1
		incr	AR(ERR,Er$Other)  -1
		set	AR(ERR,$ErrNum,Stato)  $Opz
		if	{ $AR(Current,Par) == $AR(ERR,$ErrNum,Par) } {
			XDL_parOut	$AR(Current,Par)
			}
		if	{ $AR(Current,Lemma) == $AR(ERR,$ErrNum,Parola) } {
			XDL_lerTop
			}
		}
	XDL_errTop
	XDL_tipTop
	}

#	XDL_TIPMARVOLTE	-	MARCA UN TIPO DI ERRORE SE OCCORRE + DI N VOLTE
#	------------------------------------------------------------------------

proc	XDL_tipMarVolte { Volte } {

	global	AR

	foreach	ErrNum  $AR(Tipo,lsE,$AR(Current,MarTipo)) {
		lappend	ar_Tmp($AR(ERR,$ErrNum,Parola))  $ErrNum
		}
	set	ls_ErrNum  {}
	foreach	Parola  [ array  names ar_Tmp ] {
		if	{ [ llength  $ar_Tmp($Parola) ] > $Volte } {
			set	ls_ErrNum  [ concat  $ls_ErrNum $ar_Tmp($Parola) ]
			}
		}
	foreach	ErrNum  $ls_ErrNum {
		if	{ $AR(ERR,$ErrNum,Stato) != "S" } {
			continue
			}
		.ert.txt.dat	tag remove  ErS  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		.ert.txt.dat	tag add  ErM  "$ErrNum.0 linestart" "$ErrNum.0 lineend"
		XDL_lemTestMar	$AR(ERR,$ErrNum,Parola) "M"
		XDL_tipTestMar	$AR(ERR,$ErrNum,Tipo) "M"
		incr	AR(Par,ErM,$AR(ERR,$ErrNum,Par))
		incr	AR(ERR,ErM)
		incr	AR(Par,ErS,$AR(ERR,$ErrNum,Par))  -1
		incr	AR(ERR,ErS)  -1
		set	AR(ERR,$ErrNum,Stato)  M
		if	{ $AR(Current,Par) == $AR(ERR,$ErrNum,Par) } {
			XDL_parOut	$AR(Current,Par)
			}
		if	{ $AR(Current,Lemma) == $AR(ERR,$ErrNum,Parola) } {
			XDL_lerTop
			}
		}
	XDL_errTop
	if	{ $AR(Current,MarTipo) == $AR(Current,Tipo) } {
		XDL_tipTop
		}
	}

#	XDL_TIPTESTMAR	-	VERIFICA STATO DI MARCATURA D'UN TIPO D'ERRORE
#	------------------------------------------------------------------------

proc	XDL_tipTestMar { Tipo Opz } {

	global	AR

	if	{ $Opz == "M" } {
		set	Other  "S"
	} else {
		set	Other  "M"
		}
	incr	AR(Tipo,Er$Opz,$Tipo)
	incr	AR(Tipo,Er$Other,$Tipo)  -1
	set	NumTipo  [ llength  $AR(Tipo,lsE,$Tipo) ]
	
	.tip.txt.dat	tag remove  ErM  "T_$Tipo.first" "T_$Tipo.last"
	.tip.txt.dat	tag remove  ErS  "T_$Tipo.first" "T_$Tipo.last"
	.tip.txt.dat	tag remove  ErC  "T_$Tipo.first" "T_$Tipo.last"
	.tip.txt.dat	tag remove  ErE  "T_$Tipo.first" "T_$Tipo.last"
	if	{ $AR(Tipo,ErM,$Tipo) > 0  &&  $AR(Tipo,ErS,$Tipo) == 0 } {
		.tip.txt.dat	tag add  ErM  "T_$Tipo.first" "T_$Tipo.last"
		return
		}
	if	{ $AR(Tipo,ErC,$Tipo) == $NumTipo } {
		.tip.txt.dat	tag add  ErC  "T_$Tipo.first" "T_$Tipo.last"
		return
		}
	if	{ $AR(Tipo,ErE,$Tipo) == $NumTipo } {
		.tip.txt.dat	tag add  ErE  "T_$Tipo.first" "T_$Tipo.last"
		return
		}
	if	{ [ expr  $AR(Tipo,ErE,$Tipo) + $AR(Tipo,ErC,$Tipo) ] == $NumTipo } {
		.tip.txt.dat	tag add  ErE  "T_$Tipo.first" "T_$Tipo.last"
		return
		}
	.tip.txt.dat	tag add  ErS  "T_$Tipo.first" "T_$Tipo.last"
	}

#	XDL_TIPPAR	-	VISUALIZZA ERRORI DA SCALA DEL TIPO ERRORE
#	------------------------------------------------------------------------

proc	XDL_tipPar { Num {Ps ""} } {

	global	AR

	if	{ $Num == "Scala" } {
		set	Num  $Ps
		set	Delta  [ expr  $Num - $AR(Current,TipSca) ]
		if	{ $Delta != 0 } {
			set	Segno  [ expr  $Delta / abs($Delta) ]
			set	Conf  0
			set	NumErr  [ lindex  $AR(Tipo,lsE,$AR(Current,Tipo)) [ expr  $Num - 1 ] ]
			if	{ $AR(ERR,$NumErr,Stato) == "C"  ||  $AR(ERR,$NumErr,Stato) == "E" } {
				set	Conf  1
				}
			if	{ $AR(Scorri,tip) == "ERR"  &&  $Conf == 1 } {
				set	NeoNum  [ expr  $Num + $Segno ]
				if	{ $NeoNum <= [ llength  $AR(Tipo,lsE,$AR(Current,Tipo)) ]  &&  $NeoNum > 0 } {
					.tip.sca	set  $NeoNum
					XDL_tipPar	"Scala" $NeoNum
					return
					}
				}
			}
		}
	if	{ $Num == 0 } {
		return
		}
	set	AR(Current,TipSca)  $Num
	set	Ind  [ expr  $Num - 1 ]
	set	ErrNum  [ lindex  $AR(Tipo,lsE,$AR(Current,Tipo)) $Ind ]
	XDL_errOut	$ErrNum
	}

#	XDL_TIPQUADRO	-	VISUALIZZA IN UNA WINDOW IL QUADRO TIPI ERRORE
#	------------------------------------------------------------------------

proc	XDL_tipQuadro {} {

	global	AR

	destroy	.qtip
	toplevel	.qtip
	lower	[ frame  .qtip.tab ]
	label	.qtip.tet  -text "Sigla"
	label	.qtip.ted  -text "Descrizione"
	label	.qtip.tel  -text "Tipo"
	label	.qtip.teq  -text "Tot"
	label	.qtip.tec  -text "C"
	label	.qtip.tee  -text "E"
	label	.qtip.tem  -text "M"
	label	.qtip.tes  -text "S"
	grid	.qtip.tet  -in .qtip.tab  -column 1  -row 0  -sticky ew
	grid	.qtip.ted  -in .qtip.tab  -column 2  -row 0  -sticky ew
	grid	.qtip.tel  -in .qtip.tab  -column 3  -row 0  -sticky ew
	grid	.qtip.teq  -in .qtip.tab  -column 4  -row 0  -sticky ew
	grid	.qtip.tec  -in .qtip.tab  -column 5  -row 0  -sticky ew
	grid	.qtip.tee  -in .qtip.tab  -column 6  -row 0  -sticky ew
	grid	.qtip.tem  -in .qtip.tab  -column 7  -row 0  -sticky ew
	grid	.qtip.tes  -in .qtip.tab  -column 8  -row 0  -sticky ew
	set	Riga  1
	foreach	Item  [ lsort  [ array  names AR  "E,*,T" ] ] {
		set	Tipo  [ lindex  [ split  $Item , ] 1 ]
		if	{ [ info  exists  AR(Tipo,lsE,$Tipo) ] == 0 } {
			continue
			}
		set	TotTipo  [ expr  $AR(Tipo,ErC,$Tipo) + $AR(Tipo,ErE,$Tipo) + $AR(Tipo,ErM,$Tipo) + $AR(Tipo,ErS,$Tipo) ]
#		button	.qtip.t$Tipo  -text $Tipo  -pady 0  -command { XDL_tipQbut }
		label	.qtip.t$Tipo  -text $Tipo  -relief sunken  -borderwidth 1
		label	.qtip.d$Tipo  -text $AR(E,$Tipo)  -relief sunken  -borderwidth 1
		label	.qtip.l$Tipo  -text $AR(E,$Tipo,T)  -relief sunken  -borderwidth 1
		label	.qtip.q$Tipo  -text $TotTipo  -relief sunken  -borderwidth 1
		label	.qtip.c$Tipo  -textvariable AR(Tipo,ErC,$Tipo)  -relief sunken  -borderwidth 1  -fg red
		label	.qtip.e$Tipo  -textvariable AR(Tipo,ErE,$Tipo)  -relief sunken  -borderwidth 1
		label	.qtip.m$Tipo  -textvariable AR(Tipo,ErM,$Tipo)  -relief sunken  -borderwidth 1  -fg red  -bg yellow
		label	.qtip.s$Tipo  -textvariable AR(Tipo,ErS,$Tipo)  -relief sunken  -borderwidth 1  -fg red  -bg white
		grid	.qtip.t$Tipo  -in .qtip.tab  -column 1  -row $Riga  -sticky ew
		grid	.qtip.d$Tipo  -in .qtip.tab  -column 2  -row $Riga  -sticky ew
		grid	.qtip.l$Tipo  -in .qtip.tab  -column 3  -row $Riga  -sticky ew
		grid	.qtip.q$Tipo  -in .qtip.tab  -column 4  -row $Riga  -sticky ew
		grid	.qtip.c$Tipo  -in .qtip.tab  -column 5  -row $Riga  -sticky ew
		grid	.qtip.e$Tipo  -in .qtip.tab  -column 6  -row $Riga  -sticky ew
		grid	.qtip.m$Tipo  -in .qtip.tab  -column 7  -row $Riga  -sticky ew
		grid	.qtip.s$Tipo  -in .qtip.tab  -column 8  -row $Riga  -sticky ew
		incr	Riga
		}
	pack	.qtip.tab
	}

#	XDL_TIPTOP	-	VISUALIZZA INFORMAZIONI SUL TIPO D'ERRORE
#	------------------------------------------------------------------------

proc	XDL_tipTop {} {

	global	AR
	
	.tip.top.dat	delete  0.0 end
	.tip.top.dat	insert end  "$AR(Current,Tipo)"  Evidenzia
	.tip.top.dat	insert end  [ format  "%17s\n" "marcati: $AR(Tipo,ErM,$AR(Current,Tipo))" ]
	.tip.top.dat	insert end  [ format  "%20.20s\n" "$AR(E,$AR(Current,Tipo))" ]
	.tip.top.dat	insert end  [ format  "%20s\n" "non marcati: $AR(Tipo,ErS,$AR(Current,Tipo))" ]
	.tip.top.but.mar	config  -state disabled
	.tip.top.but.sma	config  -state disabled
	if	{ $AR(Tipo,ErM,$AR(Current,Tipo)) > 0 } {
		.tip.top.but.sma	config  -state normal
		}
	if	{ $AR(Tipo,ErS,$AR(Current,Tipo)) > 0 } {
		.tip.top.but.mar	config  -state normal
		}
	}

#	XDL_WIDATTIVA	-	ATTIVA I WIDGET OPPORTUNI
#	------------------------------------------------------------------------

proc	XDL_widAttiva { Tipo } {

	global	AR

	if	{ $Tipo == "TCAR" } {
		.mnu.f.m	entryconfig "Ricarica il testo"  -state normal
		.mnu.f.m	entryconfig "Informazioni su questo testo"  -state normal
		.mnu.f.m	entryconfig "Analizza gli errori"  -state normal
		.mnu.f.m	entryconfig "Analizza solo i lemmi"  -state normal
		.mnu.f.m	entryconfig "Lemmi pi utilizzati"  -state normal
		.mnu.f.m	entryconfig "Cerca probabili nomi propri"  -state normal
		}

	if	{ $Tipo == "TLEM"  ||  $Tipo == "TERR" } {
		.par.mnu	config  -state normal
		.lva.mnu	config  -state normal
		set	AR(Current,Tag)  0
		}

	if	{ $Tipo == "TERR" } {
		.lva.mnu.t	entryconfig "accesso rapido"  -state normal
		.ert.mnu	config  -state normal
		.ler.mnu	config  -state normal
		.tip.mnu	config  -state normal
		.err.not.ent	config  -state normal
		bind	.err.not.ent <Leave>  { global AR ; set  AR(ERR,$AR(Current,Err),Nota) [ .err.not.ent  get ] }
		set	AR(Current,VisC)  0
		set	AR(Current,VisE)  0
		set	AR(Current,VisM)  0
		set	AR(Current,VisS)  0
		}
	}

#	XDL_WIDDISATT	-	DISATTIVA I WIDGET OPPORTUNI E PULISCE AR
#	------------------------------------------------------------------------

proc	XDL_widDisatt { Tipo } {

	global	AR

	if	{ $Tipo == "TCAR" } {
		.mnu.f.m	entryconfig "Ricarica il testo"  -state disabled
		.mnu.f.m	entryconfig "Informazioni su questo testo"  -state disabled
		.mnu.f.m	entryconfig "Analizza gli errori"  -state disabled
		.mnu.f.m	entryconfig "Analizza solo i lemmi"  -state disabled
		.mnu.f.m	entryconfig "Lemmi pi utilizzati"  -state disabled
		.mnu.f.m	entryconfig "Cerca probabili nomi propri"  -state disabled
		}

	if	{ $Tipo == "TCAR" } {
		.par.mnu	config  -state disabled
		.lva.mnu	config  -state disabled
		}

	if	{ $Tipo == "TLEM" } {
		.lva.mnu.t	entryconfig "accesso rapido"  -state disabled
		}

	if	{ $Tipo == "TCAR"  ||  $Tipo == "TLEM" } {
		.ert.mnu	config  -state disabled
		.ler.mnu	config  -state disabled
		.tip.mnu	config  -state disabled
		}

	if	{ $Tipo == "TCAR"  ||  $Tipo == "TLEM"  ||  $Tipo == "TERR" } {
		.err.mnu	config  -state disabled
		.err.num	config  -text ""
		.err.sta	config  -text ""
		.err.tip	config  -text ""
		.err.txt	config  -text ""
		.err.str	config  -text ""
		.err.not.ent	delete  0 end
		.err.not.ent	config  -state disabled
		bind	.err.not.ent <Leave>  {}
		.ert.top.dat	delete  0.0 end
		.par.top.dat	delete  0.0 end
		.tip.top.dat	delete  0.0 end
		.ler.top.ent	delete  0 end
		.ler.top.dat	delete  0.0 end
		.lva.top.ent	delete  0 end
		.lva.top.dat	delete  0.0 end
		.ert.txt.dat	delete  0.0 end
		.par.txt.dat	delete  0.0 end
		.tip.txt.dat	delete  0.0 end
		.ler.txt.dat	delete  0.0 end
		.lva.txt.dat	delete  0.0 end
		}

	if	{ $Tipo == "TCAR"  ||  $Tipo == "TLEM"  ||  $Tipo == "TERR" } {
		.ert.top.but.mar	config  -state disabled
		.ert.top.but.sma	config  -state disabled
		.ler.top.but.mar	config  -state disabled
		.ler.top.but.sma	config  -state disabled
		.par.top.but.mar	config  -state disabled
		.par.top.but.sma	config  -state disabled
		.tip.top.but.mar	config  -state disabled
		.tip.top.but.sma	config  -state disabled
		}

	if	{ $Tipo == "TCAR" } {
		.par.sca  config  -from 0  -to 0  -tickinterval 1
		}

	if	{ $Tipo == "TCAR"  ||  $Tipo == "TLEM"  ||  $Tipo == "TERR" } {
		.ert.sca  config  -from 0  -to 0  -tickinterval 1
		.tip.sca  config  -from 0  -to 0  -tickinterval 1
		.ler.sca  config  -from 0  -to 0  -tickinterval 1
		.lva.sca  config  -from 0  -to 0  -tickinterval 1
		}

	if	{ $Tipo == "TCAR" } {
		catch	{ close  $AR(File,PF) }
		}

	if	{ $Tipo == "TCAR" } {
		set	AR(File,Par)  0
		set	AR(File,Parole)  0
		set	AR(File,ByteTesto)  0
		set	AR(File,Pos,0)  0
		set	AR(File,Tag)  $AR(Flag,Tag)
		foreach	Item  [ array  names AR "Par,*" ] {
			unset	AR($Item)
			}
		}

	if	{ $Tipo == "TCAR"  ||  $Tipo == "TLEM"  ||  $Tipo == "TERR" } {
		set	AR(Par)  0
		set	AR(File,Err)  0
		foreach	Item  [ array  names AR "Current,*" ] {
			set	AR($Item)  0
			}
		foreach	Item  [ array  names AR "Lem,*" ] {
			unset	AR($Item)
			}
		foreach	Item  [ array  names AR "Tipo,*" ] {
			unset	AR($Item)
			}
		foreach	Item  [ array  names AR "ERR,*" ] {
			unset	AR($Item)
			}
		set	AR(ERR,ErC)  0
		set	AR(ERR,ErE)  0
		set	AR(ERR,ErM)  0
		set	AR(ERR,ErS)  0
		}

	if	{ $Tipo == "TLEM"  ||  $Tipo == "TERR" } {
		set	AR(Current,Lemma)  ""
		set	AR(Current,Tipo)  ""
		foreach	Item  [ array  names AR "Par,ErC,*" ] {
			set	AR($Item)  0
			}
		foreach	Item  [ array  names AR "Par,ErE,*" ] {
			set	AR($Item)  0
			}
		foreach	Item  [ array  names AR "Par,ErM,*" ] {
			set	AR($Item)  0
			}
		foreach	Item  [ array  names AR "Par,ErS,*" ] {
			set	AR($Item)  0
			}
		foreach	Item  [ array  names AR "Par,lsE,*" ] {
			set	AR($Item)  {}
			}
		}
	}

 #####									 #####
 #									     #
#	X	INIZIALIZZAZIONE TIPI ERRORE				      #
 #									     #
 #####									 #####

set	AR(E,NRE)  "numero romano errato"
set	AR(E,4_C)  "quattro consonanti di seguito"
set	AR(E,I3C)  "tre consonanti iniziali non ammesse"
set	AR(E,I2C)  "due consonanti iniziali non ammesse"
set	AR(E,3_C)  "tre consonanti di seguito non ammesse"
set	AR(E,DCF)  "doppia consonante finale"
set	AR(E,SCF)  "singola consonante finale"
set	AR(E,3_V)  "tre vocali di seguito non ammesse"
set	AR(E,2VU)  "due vocali uguali non ammesse"
set	AR(E,LUF)  "lettera U finale"
set	AR(E,LKP)  "lettere J/K/W/X/Y nella parola"
set	AR(E,?H?)  "uso errato dell'H"
set	AR(E,?Q?)  "uso errato della Q"
set	AR(E,DIP)  "lemma sconosciuto"
set	AR(E,DIN)  "lemma sconosciuto (nome proprio?)"
set	AR(E,NLI)  "numeri e lettere insieme"
set	AR(E,MMI)  "maiuscole e minuscole insieme"
set	AR(E,A_A)  "accento finale acuto invece che grave"
set	AR(E,A_G)  "accento finale grave invece che acuto"
set	AR(E,NRE,T)  L
set	AR(E,4_C,T)  L
set	AR(E,I3C,T)  L
set	AR(E,I2C,T)  L
set	AR(E,3_C,T)  L
set	AR(E,DCF,T)  L
set	AR(E,SCF,T)  L
set	AR(E,3_V,T)  L
set	AR(E,2VU,T)  L
set	AR(E,LUF,T)  L
set	AR(E,LKP,T)  L
set	AR(E,?H?,T)  L
set	AR(E,?Q?,T)  L
set	AR(E,DIP,T)  L
set	AR(E,DIN,T)  L
set	AR(E,NLI,T)  L
set	AR(E,MMI,T)  L
set	AR(E,A_A,T)  L
set	AR(E,A_G,T)  L

set	AR(E,SAC)  "terminazione consonante e apostrofo"
set	AR(E,UEA)  "uso errato apostrofo"
set	AR(E,SDA)  "spazio dopo apostrofo"
set	AR(E,RDS)  "doppia spaziatura"
set	AR(E,RPS)  "punteggiatura senza spazio dopo"
set	AR(E,RSP)  "spazio con punteggiatura dopo"
set	AR(E,RDP)  "riga, punteggiatura doppia"
set	AR(E,GPN)  "segno di grado/percentuale non corretto"
set	AR(E,IMI)  "iniziale a minuscolo"
set	AR(E,ISP)  "iniziale senza punto dopo"
set	AR(E,OCR)  "poss err OCR"
set	AR(E,INM)  "poss err OCR: inondo <=> mondo"
set	AR(E,OSE)  "poss err OCR: se <=> sa <=> so"
set	AR(E,OPO)  "poss err OCR: por <=> per <=> par"
set	AR(E,IIL)  "poss err OCR: II <=> il"
set	AR(E,MAP)  "manca apostrofo dopo 'po'"
set	AR(E,AIF)  "art ind femm / sost mas"
set	AR(E,AIM)  "art ind mas / sost femm"
set	AR(E,ADF)  "sost femm dopo art det mas"
set	AR(E,ADM)  "sost mas dopo art det femm"
set	AR(E,SAC,T)  R
set	AR(E,UEA,T)  R
set	AR(E,SDA,T)  R
set	AR(E,RDS,T)  R
set	AR(E,RPS,T)  R
set	AR(E,RSP,T)  R
set	AR(E,RDP,T)  R
set	AR(E,GPN,T)  R
set	AR(E,IMI,T)  R
set	AR(E,ISP,T)  R
set	AR(E,OCR,T)  R
set	AR(E,INM,T)  R
set	AR(E,OSE,T)  R
set	AR(E,OPO,T)  R
set	AR(E,IIL,T)  R
set	AR(E,MAP,T)  R
set	AR(E,AIF,T)  R
set	AR(E,AIM,T)  R
set	AR(E,ADF,T)  R
set	AR(E,ADM,T)  R

 #####									 #####
 #									     #
#	X	INIZIALIZZAZIONE GENERALE VIDEO				      #
 #									     #
 #####									 #####

frame	.mnu
pack	.mnu  -expand no  -fill x

labelframe	.err  -bd 1  -relief sunken
pack	.err  -expand no  -fill x  -ipady 3
menubutton	.err.mnu  -state disabled  -text "Errore corrente"  -borderwidth 2  -relief ridge  -menu .err.mnu.t
.err	config  -labelwidget .err.mnu
menu	.err.mnu.t  -tearoff no
.err.mnu.t	add command  -label "Annulla conferma/esclusione"  -command { XDL_errAnnConf }

frame	.sld
pack	.sld  -expand yes  -fill both
label	.msg  -compound left
pack	.msg  -expand no  -fill x

frame	.epa
pack	.epa  -expand yes  -fill both  -in .sld  -side left
frame	.lem
pack	.lem  -expand no  -fill y  -in .sld  -side left

frame	.erc
pack	.erc  -expand no  -fill x  -in .epa
labelframe	.par  -bd 2  -relief sunken
pack	.par  -expand yes  -fill both  -in .epa
menubutton	.par.mnu  -state disabled  -text "Paragrafi / Errori paragrafo"  -borderwidth 2  -relief ridge  -menu .par.mnu.t
.par	config  -labelwidget .par.mnu
menu	.par.mnu.t  -tearoff no
set	AR(Scorri,par)  ALL
.par.mnu.t	add command  -label "Scorri solo errori presenti"  -command { XDL_Scorri par }
.par.mnu.t	add cascade  -label "salva"  -menu .par.mnu.t.s
menu	.par.mnu.t.s  -tearoff no
.par.mnu.t.s	add command  -label "Salva testo paragrafo"  -command { XDL_parSalva }

labelframe	.ert  -bd 2  -relief sunken
pack	.ert  -expand yes  -fill x  -in .erc  -side left
menubutton	.ert.mnu  -state disabled  -text "Errori"  -borderwidth 2  -relief ridge  -menu .ert.mnu.t
.ert	config  -labelwidget .ert.mnu
menu	.ert.mnu.t  -tearoff no
.ert.mnu.t	add cascade  -label "conferme"  -menu .ert.mnu.t.c
menu	.ert.mnu.t.c
.ert.mnu.t.c	add command  -label "Conferma gli errori marcati"  -command { XDL_errConf M }
.ert.mnu.t.c	add command  -label "Esclusione degli errori marcati"  -command { XDL_errEscl M }
.ert.mnu.t	add cascade  -label "marcature"  -menu .ert.mnu.t.m
menu	.ert.mnu.t.m  -tearoff no
.ert.mnu.t.m	add command  -label "Marca gli errori selezionati"  -command { XDL_errMarSel  M }
.ert.mnu.t.m	add command  -label "Marca tutti gli errori"  -command {
	global	AR
	.ert.txt.dat  tag add  sel  0.0 $AR(File,Err).1
	XDL_errMarSel  M
	}
.ert.mnu.t.m	add separator
.ert.mnu.t.m	add command  -label "Smarca gli errori selezionati"  -command { XDL_errMarSel  S }
set	AR(Scorri,ert)  ALL
.ert.mnu.t	add command  -label "Scorri solo errori presenti"  -command { XDL_Scorri ert }
.ert.mnu.t	add cascade  -label "salva"  -menu .ert.mnu.t.s
menu	.ert.mnu.t.s  -tearoff no
.ert.mnu.t.s	add command  -label "Salva testo degli errori confermati"  -command { XDL_errSalva C }
.ert.mnu.t.s	add separator
.ert.mnu.t.s	add command  -label "Salva testo di tutti gli errori"  -command { XDL_errSalva T }
.ert.mnu.t.s	add command  -label "Salva testo degli errori esclusi"  -command { XDL_errSalva E }
.ert.mnu.t.s	add command  -label "Salva testo degli errori marcati"  -command { XDL_errSalva M }
.ert.mnu.t.s	add command  -label "Salva testo degli errori smarcati"  -command { XDL_errSalva S }
.ert.mnu.t	add cascade  -label "visualizza errori"  -menu .ert.mnu.t.v
menu	.ert.mnu.t.v  -tearoff no
.ert.mnu.t.v	add checkbutton  -label "Confermati"  -variable AR(Current,VisC)  -onvalue 0  -offvalue 1 \
		-command { global AR ; .ert.txt.dat  tag config  ErC  -elide $AR(Current,VisC) }
.ert.mnu.t.v	add checkbutton  -label "Esclusi"  -variable AR(Current,VisE)  -onvalue 0  -offvalue 1 \
		-command { global AR ; .ert.txt.dat  tag config  ErE  -elide $AR(Current,VisE) }
.ert.mnu.t.v	add checkbutton  -label "Marcati"  -variable AR(Current,VisM)  -onvalue 0  -offvalue 1 \
		-command { global AR ; .ert.txt.dat  tag config  ErM  -elide $AR(Current,VisM) }
.ert.mnu.t.v	add checkbutton  -label "Non marcati"  -variable AR(Current,VisS)  -onvalue 0  -offvalue 1 \
		-command { global AR ; .ert.txt.dat  tag config  ErS  -elide $AR(Current,VisS) }
.ert.mnu.t.v	add separator
.ert.mnu.t.v	add command  -label "Tutti"  -command {
	global AR
	.ert.txt.dat  tag config  ErC  -elide 0
	.ert.txt.dat  tag config  ErE  -elide 0
	.ert.txt.dat  tag config  ErM  -elide 0
	.ert.txt.dat  tag config  ErS  -elide 0
	set	AR(Current,VisC)  0
	set	AR(Current,VisE)  0
	set	AR(Current,VisM)  0
	set	AR(Current,VisS)  0
	}

labelframe	.tip  -text "Tipi errore"  -bd 2  -relief sunken
pack	.tip  -expand no  -fill none  -in .erc  -side left
menubutton	.tip.mnu  -state disabled  -text "Tipi errore"  -borderwidth 2  -relief ridge  -menu .tip.mnu.t
.tip	config  -labelwidget .tip.mnu
menu	.tip.mnu.t  -tearoff no
.tip.mnu.t	add cascade  -label "marca"  -menu .tip.mnu.t.m
menu	.tip.mnu.t.m  -tearoff no
.tip.mnu.t.m	add command  -label "Occorrenze che ricorrono pi di 5 volte"  -command { XDL_tipMarVolte  5 }
.tip.mnu.t.m	add command  -label "Occorrenze che ricorrono pi di 10 volte"  -command { XDL_tipMarVolte  10 }
set	AR(Scorri,tip)  ALL
.tip.mnu.t	add command  -label "Scorri solo errori presenti"  -command { XDL_Scorri tip }
.tip.mnu.t	add command  -label "Quadro generale"  -command { XDL_tipQuadro }

labelframe	.ler  -bd 2  -relief sunken
pack	.ler  -expand yes  -fill y  -in .lem
menubutton	.ler.mnu  -state disabled  -text "Lemmi in errore"  -borderwidth 2  -relief ridge  -menu .ler.mnu.t
.ler	config  -labelwidget .ler.mnu
menu	.ler.mnu.t  -tearoff no
.ler.mnu.t	add cascade  -label "marcature"  -menu .ler.mnu.t.m
menu	.ler.mnu.t.m  -tearoff no
.ler.mnu.t.m	add command  -label "Marca i lemmi selezionati"  -command { XDL_lerMarSel  M }
.ler.mnu.t.m	add command  -label "Marca tutti i lemmi in errore"  -command { XDL_lerMarTutti  M 0 }
.ler.mnu.t.m	add command  -label "Marca i lemmi in errore che ricorrono pi di 5 volte"  -command { XDL_lerMarTutti  M 6 }
.ler.mnu.t.m	add command  -label "Marca i lemmi in errore che ricorrono pi di 10 volte"  -command { XDL_lerMarTutti  M 11 }
.ler.mnu.t.m	add separator
.ler.mnu.t.m	add command  -label "Smarca i lemmi selezionati"  -command { XDL_lerMarSel  S }
.ler.mnu.t.m	add command  -label "Smarca tutti i lemmi in errore"  -command { XDL_lerMarTutti  S 0 }
set	AR(Scorri,ler)  ALL
.ler.mnu.t	add command  -label "Scorri solo errori presenti"  -command { XDL_Scorri ler }
.ler.mnu.t	add cascade  -label "accesso rapido"  -menu .ler.mnu.t.a
menu	.ler.mnu.t.a
foreach	Lettera  [ list  A B C D E F G H I J K L M N O P Q R S T U V W X Y Z ] {
	.ler.mnu.t.a	add command  -label $Lettera  -command "XDL_lemAlfa  LER $Lettera"
	}
foreach	Lettera  [ list  A H O V ] {
	.ler.mnu.t.a	entryconfig $Lettera  -columnbreak yes
	}
.ler.mnu.t	add cascade  -label "salva"  -menu .ler.mnu.t.s
menu	.ler.mnu.t.s  -tearoff no
.ler.mnu.t.s	add cascade  -label "tutti"  -menu .ler.mnu.t.s.t
menu	.ler.mnu.t.s.t  -tearoff no
.ler.mnu.t.s.t	add command  -label "Cos come sono"  -command { XDL_lemSalva LER }
.ler.mnu.t.s.t	add command  -label "In formato dizionario"  -command { XDL_lemSalDiz LER }
.ler.mnu.t.s	add cascade  -label "confermati"  -menu .ler.mnu.t.s.c
menu	.ler.mnu.t.s.c  -tearoff no
.ler.mnu.t.s.c	add command  -label "Cos come sono"  -command { XDL_lemSalva LER C }
.ler.mnu.t.s.c	add command  -label "In formato dizionario"  -command { XDL_lemSalDiz LER C }
.ler.mnu.t.s	add cascade  -label "esclusi"  -menu .ler.mnu.t.s.e
menu	.ler.mnu.t.s.e  -tearoff no
.ler.mnu.t.s.e	add command  -label "Cos come sono"  -command { XDL_lemSalva LER E }
.ler.mnu.t.s.e	add command  -label "In formato dizionario"  -command { XDL_lemSalDiz LER E }
.ler.mnu.t.s	add cascade  -label "marcati"  -menu .ler.mnu.t.s.m
menu	.ler.mnu.t.s.m  -tearoff no
.ler.mnu.t.s.m	add command  -label "Cos come sono"  -command { XDL_lemSalva LER M }
.ler.mnu.t.s.m	add command  -label "In formato dizionario"  -command { XDL_lemSalDiz LER M }
.ler.mnu.t	add cascade  -label "integra nel dizionario in memoria"  -menu .ler.mnu.t.i
menu	.ler.mnu.t.i  -tearoff no
.ler.mnu.t.i	add command  -label "Lemmi esclusi"  -command { XDL_lerDiz  E }
.ler.mnu.t.i	add command  -label "Lemmi marcati"  -command { XDL_lerDiz  M }

labelframe	.lva  -bd 2  -relief sunken
pack	.lva  -expand yes  -fill y  -in .lem
menubutton	.lva.mnu  -state disabled  -text "Lemmi validi"  -borderwidth 2  -relief ridge  -menu .lva.mnu.t
.lva	config  -labelwidget .lva.mnu
menu	.lva.mnu.t  -tearoff no
.lva.mnu.t	add cascade  -label "accesso rapido"  -menu .lva.mnu.t.a
menu	.lva.mnu.t.a
foreach	Lettera  [ list  A B C D E F G H I J K L M N O P Q R S T U V W X Y Z ] {
	.lva.mnu.t.a	add command  -label $Lettera  -command "XDL_lemAlfa  LVA $Lettera"
	}
foreach	Lettera  [ list  A H O V ] {
	.lva.mnu.t.a	entryconfig $Lettera  -columnbreak yes
	}
.lva.mnu.t	add cascade  -label "salva"  -menu .lva.mnu.t.s
menu	.lva.mnu.t.s  -tearoff no
.lva.mnu.t.s	add command  -label "Cos come sono"  -command { XDL_lemSalva LVA }
.lva.mnu.t.s	add command  -label "In formato dizionario"  -command { XDL_lemSalDiz LVA }

set	RigErt  10
set	RigPar  24
set	AR(Font,Size)  12
if	{ [ lindex  [ wm  maxsize . ] 1 ] < 850 } {
	set	RigErt  6
	set	RigPar  16
	set	AR(Font,Size)  8
	}

 #####									 #####
 #									     #
#	X	INIZIALIZZAZIONE GENERALE MENU IN ALTO			      #
 #									     #
 #####									 #####

menubutton	.mnu.f  -text "Testo"  -borderwidth 2  -relief ridge  -menu .mnu.f.m
pack	.mnu.f  -side left
menu	.mnu.f.m  -tearoff no
.mnu.f.m	add command  -label "Carica"  -command { global AR ; set  AR(Flag,NomeFile) "" ; XDL_testoCar }
.mnu.f.m	add command  -state disabled  -label "Ricarica il testo"  -command XDL_testoCar
.mnu.f.m	add command  -state disabled  -label "Informazioni su questo testo"  -command XDL_testoInfo
.mnu.f.m	add checkbutton  -label "Carica testo senza tag \"<>\"?"  -variable AR(Flag,Tag)
.mnu.f.m	add separator
.mnu.f.m	add command  -state disabled  -label "Analizza gli errori"  -command { XDL_testoErr }
.mnu.f.m	add separator
.mnu.f.m	add command  -state disabled  -label "Analizza solo i lemmi"  -command { XDL_testoLem L }
.mnu.f.m	add command  -state disabled  -label "Lemmi pi utilizzati"  -command { XDL_testoLem U }
.mnu.f.m	add command  -state disabled  -label "Cerca probabili nomi propri"  -command { XDL_testoNom }

menubutton	.mnu.d  -text "Dizionari"  -borderwidth 2  -relief ridge  -menu .mnu.d.m
pack	.mnu.d  -side left
menu	.mnu.d.m  -tearoff no
.mnu.d.m	add command  -label "Cambia il dizionario base"  -command { XDL_dizCambia }
.mnu.d.m	add command  -label "Carica integrazioni al dizionario base"  -command { XDL_dizCarInt }
.mnu.d.m	add separator
.mnu.d.m	add command  -label "Informazioni sui dizionari"  -command { XDL_dizInfo }

menubutton	.mnu.o  -text "Opzioni"  -borderwidth 2  -relief ridge  -menu .mnu.o.m
pack	.mnu.o  -side left
menu	.mnu.o.m  -tearoff no
.mnu.o.m	add cascade  -label "accenti"  -menu .mnu.o.m.c
menu	.mnu.o.m.c  -tearoff no
.mnu.o.m.c	add radiobutton  -label "Italiano moderno (1)"  -variable AR(Flag,Accentazione)  -value "italiano moderno (1)" \
		-command { XDL_cambioAcc "italiano moderno (1)" }
.mnu.o.m.c	add radiobutton  -label "Italiano moderno (2)"  -variable AR(Flag,Accentazione)  -value "italiano moderno (2)" \
		-command { XDL_cambioAcc "italiano moderno (2)" }
.mnu.o.m.c	add radiobutton  -label "Solo accenti gravi"  -variable AR(Flag,Accentazione)  -value "solo accenti gravi" \
		-command { XDL_cambioAcc "solo accenti gravi" }
set	AR(Flag,Accentazione)  "italiano moderno (1)"
set	AR(Flag,OldAcc)  "italiano moderno (1)"
.mnu.o.m	add separator
.mnu.o.m	add cascade  -label "colore"  -menu .mnu.o.m.p
menu	.mnu.o.m.p
.mnu.o.m.p	add command  -label "Arancio"  -command { tk_setPalette "#fad087" }
.mnu.o.m.p	add command  -label "Azzurro"  -command { tk_setPalette "#aeeeee" }
.mnu.o.m.p	add command  -label "Beige"  -command { tk_setPalette "#ffe7ba" }
.mnu.o.m.p	add command  -label "Giallo"  -command { tk_setPalette "#eeee66" }
.mnu.o.m.p	add command  -label "Grigio"  -command { tk_setPalette "#e0eee0" }
.mnu.o.m.p	add command  -label "Rosa"  -command { tk_setPalette "#eea9b8" }
.mnu.o.m.p	add command  -label "Verde"  -command { tk_setPalette "#b4eeb4" }
.mnu.o.m.p	add command  -label "Viola"  -command { tk_setPalette "#ccc3f9" }
.mnu.o.m	add cascade  -label "dimensione caratteri"  -menu .mnu.o.m.s
menu	.mnu.o.m.s  -tearoff no
.mnu.o.m.s	add radiobutton  -label "8 punti"  -variable "AR(Font,Size)"  -value "8" \
		-command { XDL_fontsize 8 }
.mnu.o.m.s	add radiobutton  -label "9 punti"  -variable "AR(Font,Size)"  -value "9" \
		-command { XDL_fontsize 9 }
.mnu.o.m.s	add radiobutton  -label "10 punti"  -variable "AR(Font,Size)"  -value "10" \
		-command { XDL_fontsize 10 }
.mnu.o.m.s	add radiobutton  -label "11 punti"  -variable "AR(Font,Size)"  -value "11" \
		-command { XDL_fontsize 11 }
.mnu.o.m.s	add radiobutton  -label "12 punti"  -variable "AR(Font,Size)"  -value "12" \
		-command { XDL_fontsize 12 }
.mnu.o.m.s	add radiobutton  -label "14 punti"  -variable "AR(Font,Size)"  -value "14" \
		-command { XDL_fontsize 14 }
.mnu.o.m.s	add radiobutton  -label "16 punti"  -variable "AR(Font,Size)"  -value "16" \
		-command { XDL_fontsize 16 }

menubutton	.mnu.e  -text "Esci"  -borderwidth 2  -relief ridge  -menu .mnu.e.m
pack	.mnu.e  -side right
menu	.mnu.e.m  -tearoff no
set	AR(File,PF)  stdin
.mnu.e.m	add command  -label "Conferma uscita"  -command  { exit }
bind	. <Destroy>  { if { "%W" == "." } { global AR ; close $AR(File,PF) } }

 #####									 #####
 #									     #
#	X	INIZIALIZZAZIONE GENERALE	ALTRI WIDGET		      #
 #									     #
 #####									 #####

frame	.err.top  -bd 0
pack	.err.top  -expand yes  -fill x
label	.err.num  -bd 1  -relief sunken  -bg yellow  -fg red
pack	.err.num  -in .err.top  -expand no  -fill x  -side left
label	.err.sta  -bd 1  -relief sunken  -bg yellow
pack	.err.sta  -in .err.top  -expand no  -fill x  -side left
label	.err.tip  -bd 1  -relief sunken  -bg yellow  -fg red
pack	.err.tip  -in .err.top  -expand yes  -fill x  -side left
label	.err.str  -bd 1  -relief sunken  -bg yellow  -fg red
pack	.err.str  -in .err.top  -expand yes  -fill x  -side left
label	.err.txt  -bd 1  -relief sunken  -bg yellow  -fg red
pack	.err.txt  -in .err.top  -expand yes  -fill x  -side left
frame	.err.not  -bd 0
pack	.err.not  -expand yes  -fill x
label	.err.not.lab  -text "nota:"
pack	.err.not.lab  -expand no  -fill none  -side left
entry	.err.not.ent  -foreground blue  -font [ list  Courier $AR(Font,Size) bold ]  -state disabled
pack	.err.not.ent  -expand yes  -fill x  -side left

frame	.ert.top
pack	.ert.top  -expand no  -fill x
text	.ert.top.dat  -width 1  -height 3  -relief flat
pack	.ert.top.dat  -expand yes  -fill both  -side left
.ert.top.dat	tag config  Evidenzia  -foreground blue  -font [ list  Courier $AR(Font,Size) bold ]
bind	.ert.top.dat <ButtonRelease-1>  { focus .ert.sca }
frame	.ert.top.but
pack	.ert.top.but  -side left  -expand no  -fill y
button	.ert.top.but.mar  -text "M"  -pady 0  -state disabled  -command { XDL_errMarca M }
button	.ert.top.but.sma  -text "S"  -pady 0  -state disabled  -command { XDL_errMarca S }
pack	.ert.top.but.mar .ert.top.but.sma  -expand no  -fill x  -ipady 0
scale	.ert.sca  -orient horizontal  -from 0  -to 0  -tickinterval 1  -bd 1  -relief sunken \
		-highlightcolor red  -highlightthickness 2
pack	.ert.sca  -expand no  -fill x
frame	.ert.txt
pack	.ert.txt  -expand yes  -fill both
text	.ert.txt.dat  -width 80  -height $RigErt  -yscrollcommand { .ert.txt.scb set }
pack	.ert.txt.dat  -expand yes  -fill x  -side left
.ert.txt.dat	tag config  ErM  -foreground red  -background yellow
.ert.txt.dat	tag config  ErS  -foreground red  -background white
.ert.txt.dat	tag config  ErC  -foreground red
.ert.txt.dat	tag config  ErE  -foreground "#707070"  -overstrike yes
.ert.txt.dat	tag config  Evidenzia \
		-borderwidth 2  -relief raised  -spacing1 5  -spacing3 5  -font [ list  Courier $AR(Font,Size) bold ]
.ert.txt.dat	tag config  sel  -underline yes
bind	.ert.txt.dat <ButtonRelease-1>  { XDL_B1_ert }
scrollbar	.ert.txt.scb  -orient vertical  -command { .ert.txt.dat yview }
pack	.ert.txt.scb  -expand no  -fill y  -side left

frame	.par.top
pack	.par.top  -expand no  -fill x
text	.par.top.dat  -width 1  -height 3  -relief flat
pack	.par.top.dat  -expand yes  -fill both  -side left
.par.top.dat	tag config  Evidenzia  -foreground blue  -font [ list  Courier $AR(Font,Size) bold ]
bind	.par.top.dat <ButtonRelease-1>  { focus .par.sca }
frame	.par.top.but
pack	.par.top.but  -side left  -expand no  -fill y
button	.par.top.but.mar  -text "M"  -pady 0  -state disabled  -command { XDL_parMarca M }
button	.par.top.but.sma  -text "S"  -pady 0  -state disabled  -command { XDL_parMarca S }
pack	.par.top.but.mar .par.top.but.sma  -expand no  -fill x  -ipady 0
scale	.par.sca  -orient horizontal  -from 0  -to 0  -tickinterval 1  -bd 1  -relief sunken \
		-highlightcolor red  -highlightthickness 2
pack	.par.sca  -expand no  -fill x
frame	.par.txt
pack	.par.txt  -expand yes  -fill both
text	.par.txt.dat  -width 80  -height $RigPar  -wrap word  -yscrollcommand { .par.txt.scb set }
pack	.par.txt.dat  -expand yes  -fill both  -side left
.par.txt.dat	tag config  ErM  -foreground red  -background yellow
.par.txt.dat	tag config  ErS  -foreground red  -background white
.par.txt.dat	tag config  ErC  -foreground red
.par.txt.dat	tag config  ErE  -foreground black
.par.txt.dat	tag config  Evidenzia \
		-borderwidth 2  -font [ list  Courier $AR(Font,Size) bold ]
.par.txt.dat	tag config  TagCode  -foreground blue    -font [ list  Courier $AR(Font,Size) italic ]
.par.txt.dat	tag config  sel  -underline yes
bind	.par.txt.dat <ButtonRelease-1>  { XDL_B1_par }
scrollbar	.par.txt.scb  -orient vertical  -command { .par.txt.dat yview }
pack	.par.txt.scb  -expand no  -fill y  -side left

frame	.tip.top
pack	.tip.top  -expand no  -fill x
text	.tip.top.dat  -width 1  -height 3  -relief flat
pack	.tip.top.dat  -expand yes  -fill both  -side left
.tip.top.dat	tag config  Evidenzia  -foreground blue  -font [ list  Courier $AR(Font,Size) bold ]
bind	.tip.top.dat <ButtonRelease-1>  { focus .tip.sca }
frame	.tip.top.but
pack	.tip.top.but  -side left  -expand no  -fill y
button	.tip.top.but.mar  -text "M"  -pady 0  -state disabled  -command { XDL_tipMarca  M }
button	.tip.top.but.sma  -text "S"  -pady 0  -state disabled  -command { XDL_tipMarca  S }
pack	.tip.top.but.mar .tip.top.but.sma  -expand no  -fill x  -ipady 0
scale	.tip.sca  -orient horizontal  -from 0  -to 0  -tickinterval 1  -bd 1  -relief sunken \
		-highlightcolor red  -highlightthickness 2
pack	.tip.sca  -expand no  -fill x
frame	.tip.txt
pack	.tip.txt  -expand yes  -fill y
text	.tip.txt.dat  -height $RigErt  -width 25  -yscrollcommand { .tip.txt.scb set }
pack	.tip.txt.dat  -expand yes  -fill y  -side left
.tip.txt.dat	tag config  ErM  -foreground red  -background yellow
.tip.txt.dat	tag config  ErS  -foreground red  -background white
.tip.txt.dat	tag config  ErC  -foreground red
.tip.txt.dat	tag config  ErE  -foreground "#707070"  -overstrike yes
.tip.txt.dat	tag config  Evidenzia \
		-borderwidth 2  -relief raised  -spacing1 5  -spacing3 5  -font [ list  Courier $AR(Font,Size) bold ]
.tip.txt.dat	tag config  sel  -underline yes
bind	.tip.txt.dat <ButtonRelease-1>  { XDL_B1_tip }
scrollbar	.tip.txt.scb  -orient vertical  -command { .tip.txt.dat yview }
pack	.tip.txt.scb  -expand no  -fill y  -side left

frame	.ler.top
pack	.ler.top  -expand no  -fill x
entry	.ler.top.ent  -foreground blue  -font [ list  Courier $AR(Font,Size) bold ]
text	.ler.top.dat  -width 1  -height 2  -relief flat
pack	.ler.top.ent .ler.top.dat  -expand yes  -fill both  -side top
bind	.ler.top.ent <KeyRelease>  { XDL_lemAlfa  LER [ .ler.top.ent  get ] }
bind	.ler.top.dat <ButtonRelease-1>  { focus .ler.sca }
frame	.ler.top.but
pack	.ler.top.but  -side left  -expand no  -fill y
button	.ler.top.but.mar  -text "M"  -pady 0  -state disabled  -command { XDL_lerMarca M }
button	.ler.top.but.sma  -text "S"  -pady 0  -state disabled  -command { XDL_lerMarca S }
pack	.ler.top.but.mar .ler.top.but.sma  -expand no  -fill x  -ipady 0
scale	.ler.sca  -orient horizontal  -from 0  -to 0  -tickinterval 1  -bd 1  -relief sunken \
		-highlightcolor red  -highlightthickness 2
pack	.ler.sca  -expand no  -fill x
frame	.ler.txt
pack	.ler.txt  -expand yes  -fill y
text	.ler.txt.dat  -height $RigErt  -width 25  -yscrollcommand { .ler.txt.scb set }
.ler.txt.dat	tag config  ErM  -foreground red  -background yellow
.ler.txt.dat	tag config  ErS  -foreground red  -background white
.ler.txt.dat	tag config  ErC  -foreground red
.ler.txt.dat	tag config  ErE  -foreground "#707070"  -overstrike yes
.ler.txt.dat	tag config  Evidenzia \
		-borderwidth 2  -relief raised  -spacing1 5  -spacing3 5  -font [ list  Courier $AR(Font,Size) bold ]
.ler.txt.dat	tag config  sel  -underline yes
bind	.ler.txt.dat <ButtonRelease-1>  { XDL_B1_ler }
pack	.ler.txt.dat  -expand yes  -fill y  -side left
scrollbar	.ler.txt.scb  -orient vertical  -command { .ler.txt.dat yview }
pack	.ler.txt.scb  -expand no  -fill y  -side left

frame	.lva.top
pack	.lva.top  -expand no  -fill x
entry	.lva.top.ent  -foreground blue  -font [ list  Courier $AR(Font,Size) bold ]
text	.lva.top.dat  -width 1  -height 1  -relief flat
pack	.lva.top.ent .lva.top.dat  -expand yes  -fill both  -side top
bind	.lva.top.ent <KeyRelease>  { XDL_lemAlfa  LVA [ .lva.top.ent  get ] }
bind	.lva.top.dat <ButtonRelease-1>  { focus .lva.sca }
scale	.lva.sca  -orient horizontal  -from 0  -to 0  -tickinterval 1  -bd 1  -relief sunken \
		-highlightcolor red  -highlightthickness 2
pack	.lva.sca  -expand no  -fill x
frame	.lva.txt
pack	.lva.txt  -expand yes  -fill y
text	.lva.txt.dat  -height $RigErt  -width 25  -yscrollcommand { .lva.txt.scb set }
pack	.lva.txt.dat  -expand yes  -fill y  -side left
.lva.txt.dat	tag config  Evidenzia \
		-borderwidth 2  -relief raised  -spacing1 5  -spacing3 5  -font [ list  Courier $AR(Font,Size) bold ]
.lva.txt.dat	tag config  sel  -underline yes
bind	.lva.txt.dat <ButtonRelease-1>  { XDL_B1_lva }
scrollbar	.lva.txt.scb  -orient vertical  -command { .lva.txt.dat yview }
pack	.lva.txt.scb  -expand no  -fill y  -side left

 #####									 #####
 #									     #
#	X	INIZIALIZZAZIONE GENERALE	OPERAZIONI AUTOMATICHE	      #
 #									     #
 #####									 #####

XDL_fontsize	$AR(Font,Size)

if	{ "$AR(Flag,NomeFile)" != "" } {
	tk_setPalette	$AR(Flag,Colore)
	}

set	AR(D,?,vers)  "?"
set	AR(D,?,desc)  "(informazioni su dizionario non disponibili)"
set	AR(D,?,data)  ""
set	AR(D,?,tipo)  "?"
set	AR(D,OCRind)  0
set	AR(D,LER,vers)  "?"
set	AR(D,LER,desc)  "Integrazione da lemmi in errore"
set	AR(D,LER,data)  ""
set	AR(D,LER,tipo)  "LER"
set	AR(D,Base)  "ITA-20"
set	AR(Current,Analisi)  ""
XDL_dizCarica	"dizionari/$AR(D,Base).diz"
if	{ "$AR(Flag,NomeDiz)" != "" } {
	XDL_dizCarica	$AR(Flag,NomeDiz)
	}

if	{ "$AR(Flag,NomeFile)" != "" } {
	XDL_testoCar
} else {
	set	AR(Flag,Exec)  ""
	}

switch	-glob -- "$AR(Flag,Exec)" {
"ERR"	{	XDL_testoErr
		}
"NOM"	{	XDL_testoNom
		}
"LEM"	{	XDL_testoLem	L
		}
"FRQ"	{	XDL_testoLem	U
		}
	}

XDL_parBlink	raised
